"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactRouterDom = require("react-router-dom");

var _withStyles = require("../helpers/withStyles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Anchor = function Anchor(_ref) {
  var block = _ref.block,
      children = _ref.children,
      disabled = _ref.disabled,
      external = _ref.external,
      href = _ref.href,
      loading = _ref.loading,
      openInNewWindow = _ref.openInNewWindow,
      css = _ref.css,
      target = _ref.target,
      theme = _ref.theme,
      styles = _ref.styles,
      noHoverUnderline = _ref.noHoverUnderline,
      props = _objectWithoutProperties(_ref, ["block", "children", "disabled", "external", "href", "loading", "openInNewWindow", "css", "target", "theme", "styles", "noHoverUnderline"]);

  return !external && href ? _react.default.createElement(_reactRouterDom.Link, _extends({}, props, css(styles.anchor, !noHoverUnderline && styles.anchor_underlined), {
    to: href,
    disabled: disabled,
    target: openInNewWindow ? '_blank' : '_self'
  }), children) : _react.default.createElement("a", _extends({}, props, css(styles.anchor, !noHoverUnderline && styles.anchor_underlined), {
    href: href,
    target: target
  }), children);
};

var AnchorWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var color = _ref2.color;
  return {
    anchor: {
      color: color.secondary,
      cursor: 'pointer',
      textDecoration: 'none'
    },
    anchor_underlined: {
      ':hover': {
        textDecoration: 'underline'
      }
    }
  };
})(Anchor);
var _default = AnchorWithStyles;
exports.default = _default;