"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Autocomplete = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactOutsideClickHandler = _interopRequireDefault(require("react-outside-click-handler"));

var _Input = _interopRequireDefault(require("./Input"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var propTypes = {
  activeIndexOnInputChange: _propTypes.default.number,
  addClearInput: _propTypes.default.bool,
  autoFocus: _propTypes.default.bool,
  book: _propTypes.default.bool,
  clearOnSelect: _propTypes.default.bool,
  clearOnSubmit: _propTypes.default.bool,
  defaultActiveIndex: _propTypes.default.number,
  defaultValue: _propTypes.default.string,
  disabled: _propTypes.default.bool,
  hideDropdownOnSubmit: _propTypes.default.bool,
  hideLabel: _propTypes.default.bool,
  hideResultsTopBorder: _propTypes.default.bool,
  id: _propTypes.default.string,
  inline: _propTypes.default.bool,
  inputBorderless: _propTypes.default.bool,
  inputFocusBorderless: _propTypes.default.bool,
  inputOverflowEllipsis: _propTypes.default.bool,
  inputRef: _propTypes.default.func,
  inputRemoveMargins: _propTypes.default.bool,
  invalid: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  label: _propTypes.default.string,
  labelDescription: _propTypes.default.string,
  large: _propTypes.default.bool,
  maxResults: _propTypes.default.number,
  name: _propTypes.default.string,
  noResultsLabel: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.symbol]),
  onBlur: _propTypes.default.func,
  onCancel: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  onSelect: _propTypes.default.func,
  onSubmit: _propTypes.default.func,
  placeholder: _propTypes.default.string,
  prefix: _propTypes.default.symbol,
  results: _propTypes.default.arrayOf(_propTypes.default.object),
  resultsBorderless: _propTypes.default.bool,
  resultsMaxHeight: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  resultsPosition: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  resultsWidth: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  scrollResults: _propTypes.default.bool,
  showFakeValuePlaceholder: _propTypes.default.bool,
  small: _propTypes.default.bool,
  subResultPaddingUnits: _propTypes.default.number,
  underlineFocus: _propTypes.default.bool
};

var Autocomplete =
/*#__PURE__*/
function (_Component) {
  _inherits(Autocomplete, _Component);

  function Autocomplete(props) {
    var _this;

    _classCallCheck(this, Autocomplete);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Autocomplete).call(this, props));
    _this.state = {
      activeIndex: props.defaultActiveIndex || -1,
      areResultsVisible: false,
      lastEventType: null,
      value: ''
    };
    return _this;
  }

  _createClass(Autocomplete, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          activeIndexOnInputChange = _this$props.activeIndexOnInputChange,
          addClearInput = _this$props.addClearInput,
          autoFocus = _this$props.autoFocus,
          book = _this$props.book,
          clearOnSelect = _this$props.clearOnSelect,
          clearOnSubmit = _this$props.clearOnSubmit,
          defaultActiveIndex = _this$props.defaultActiveIndex,
          defaultValue = _this$props.defaultValue,
          disabled = _this$props.disabled,
          hideDropdownOnSubmit = _this$props.hideDropdownOnSubmit,
          hideLabel = _this$props.hideLabel,
          hideResultsTopBorder = _this$props.hideResultsTopBorder,
          id = _this$props.id,
          inline = _this$props.inline,
          inputBorderless = _this$props.inputBorderless,
          inputFocusBorderless = _this$props.inputFocusBorderless,
          inputOverflowEllipsis = _this$props.inputOverflowEllipsis,
          inputRef = _this$props.inputRef,
          inputRemoveMargins = _this$props.inputRemoveMargins,
          invalid = _this$props.invalid,
          inverse = _this$props.inverse,
          loading = _this$props.loading,
          label = _this$props.label,
          labelDescription = _this$props.labelDescription,
          large = _this$props.large,
          maxResults = _this$props.maxResults,
          name = _this$props.name,
          noResultsLabel = _this$props.noResultsLabel,
          onBlur = _this$props.onBlur,
          onCancel = _this$props.onCancel,
          onChange = _this$props.onChange,
          onFocus = _this$props.onFocus,
          onSelect = _this$props.onSelect,
          onSubmit = _this$props.onSubmit,
          placeholder = _this$props.placeholder,
          prefix = _this$props.prefix,
          results = _this$props.results,
          resultsBorderless = _this$props.resultsBorderless,
          resultsMaxHeight = _this$props.resultsMaxHeight,
          resultsPosition = _this$props.resultsPosition,
          resultsWidth = _this$props.resultsWidth,
          scrollResults = _this$props.scrollResults,
          showFakeValuePlaceholder = _this$props.showFakeValuePlaceholder,
          small = _this$props.small,
          subResultPaddingUnits = _this$props.subResultPaddingUnits,
          underlineFocus = _this$props.underlineFocus;
      return _react.default.createElement(_reactOutsideClickHandler.default, null, _react.default.createElement(_Input.default, {
        autoComplete: "off",
        autoFocus: autoFocus,
        book: book,
        borderless: inputBorderless,
        disabled: disabled //errorMessage={errorMessage}
        ,
        focusBorderless: inputFocusBorderless,
        hideLabel: hideLabel,
        id: id,
        inline: inline,
        inputRef: inputRef,
        invalid: invalid,
        inverse: inverse,
        label: label,
        labelDescription: labelDescription,
        large: large,
        name: name //onBlur={onBlur}
        //onChange={onChange}
        //onClear={onClear}
        //onFocus={onFocus}
        //onKeyDown={onKeyDown}
        ,
        placeholder: placeholder,
        prefix: prefix //refForFocus={refForFocus}
        ,
        removeMargins: inputRemoveMargins,
        showFakeValuePlaceholder: showFakeValuePlaceholder,
        showOverflowEllipsis: inputOverflowEllipsis,
        small: small,
        type: "text",
        underlineFocus: underlineFocus,
        value: this.state.value
      }));
    }
  }]);

  return Autocomplete;
}(_react.Component);

exports.Autocomplete = Autocomplete;
Autocomplete.propTypes = propTypes;