"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _withStyles = require("../helpers/withStyles");

var _CinnectaTheme = _interopRequireDefault(require("../themes/CinnectaTheme"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Block = function Block(_ref) {
  var alignCenter = _ref.alignCenter,
      alignEnd = _ref.alignEnd,
      alignStart = _ref.alignStart,
      border = _ref.border,
      column = _ref.column,
      css = _ref.css,
      children = _ref.children,
      fullHeight = _ref.fullHeight,
      justifyCenter = _ref.justifyCenter,
      justifyEnd = _ref.justifyEnd,
      justifyStart = _ref.justifyStart,
      gray = _ref.gray,
      horizontal = _ref.horizontal,
      largePadding = _ref.largePadding,
      maxWidth = _ref.maxWidth,
      minWidth = _ref.minWidth,
      noPadding = _ref.noPadding,
      rectangular = _ref.rectangular,
      transparent = _ref.transparent,
      styles = _ref.styles;
  return _react.default.createElement("div", css(styles.container, alignCenter && styles.alignCenter, alignEnd && styles.alignEnd, alignStart && styles.alignStart, border && styles.border, column && styles.column, fullHeight && styles.fullHeight, gray && styles.container_gray, horizontal ? styles.row : styles.column, justifyCenter && styles.justifyCenter, justifyEnd && styles.justifyEnd, justifyStart && styles.justifyStart, largePadding && styles.largePadding, !transparent && !gray && styles.background, !rectangular && styles.radius, noPadding && styles.noPadding, {
    maxWidth: maxWidth && maxWidth * _CinnectaTheme.default.unit,
    minWidth: minWidth && minWidth * _CinnectaTheme.default.unit
  }), children);
};

var BlockWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var color = _ref2.color,
      units = _ref2.units,
      radius = _ref2.radius;
  return {
    container: {
      borderRadius: radius,
      padding: units(1)
    },
    background: {
      background: color.white
    },
    alignCenter: {
      display: 'flex',
      alignItems: 'center'
    },
    alignEnd: {
      display: 'flex',
      alignItems: 'flex-end'
    },
    alignStart: {
      display: 'flex',
      alignItems: 'flex-start'
    },
    justifyCenter: {
      display: 'flex',
      justifyContent: 'center'
    },
    justifyEnd: {
      display: 'flex',
      justifyContent: 'flex-end'
    },
    justifyStart: {
      display: 'flex',
      justifyContent: 'flex-start'
    },
    row: {
      flexDirection: 'row'
    },
    column: {
      flexDirection: 'column'
    },
    noPadding: {
      padding: 0
    },
    largePadding: {
      padding: units(2)
    },
    container_gray: {
      background: color.grayLight
    },
    border: {
      borderWidth: 1,
      borderStyle: 'solid',
      borderColor: color.gray
    },
    fullHeight: {
      height: '100%'
    },
    radius: {
      borderRadius: radius
    }
  };
})(Block);
var _default = BlockWithStyles;
exports.default = _default;