"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Loader = _interopRequireDefault(require("./Loader"));

var _Shimmer = _interopRequireDefault(require("./Shimmer"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread({}, _reactWithStyles.withStylesPropTypes, {
  disabled: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  fullWidth: _propTypes.default.bool,
  block: _propTypes.default.bool,
  compact: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  large: _propTypes.default.bool,
  mono: _propTypes.default.bool,
  noSpacing: _propTypes.default.bool,
  soft: _propTypes.default.bool,
  primary: _propTypes.default.bool,
  rectangular: _propTypes.default.bool,
  secondary: _propTypes.default.bool,
  shade: _propTypes.default.bool,
  shimmer: _propTypes.default.bool,
  small: _propTypes.default.bool,
  short: _propTypes.default.bool,
  transparent: _propTypes.default.bool,
  tall: _propTypes.default.bool,
  type: _propTypes.default.string,
  underlined: _propTypes.default.bool,
  noBorder: _propTypes.default.bool,
  children: _propTypes.default.node,
  wide: _propTypes.default.bool
});

var defaultProps = {
  type: 'button'
};

var Button = function Button(_ref) {
  var styles = _ref.styles,
      children = _ref.children,
      disabled = _ref.disabled,
      loading = _ref.loading,
      fullWidth = _ref.fullWidth,
      block = _ref.block,
      compact = _ref.compact,
      inverse = _ref.inverse,
      grouped = _ref.grouped,
      groupedFirst = _ref.groupedFirst,
      groupedLast = _ref.groupedLast,
      large = _ref.large,
      mono = _ref.mono,
      noSpacing = _ref.noSpacing,
      shade = _ref.shade,
      soft = _ref.soft,
      primary = _ref.primary,
      rectangular = _ref.rectangular,
      secondary = _ref.secondary,
      shimmer = _ref.shimmer,
      short = _ref.short,
      small = _ref.small,
      transparent = _ref.transparent,
      type = _ref.type,
      underlined = _ref.underlined,
      noBorder = _ref.noBorder,
      tall = _ref.tall,
      theme = _ref.theme,
      css = _ref.css,
      href = _ref.href,
      noWrap = _ref.noWrap,
      shadowLevel = _ref.shadowLevel,
      wide = _ref.wide,
      props = _objectWithoutProperties(_ref, ["styles", "children", "disabled", "loading", "fullWidth", "block", "compact", "inverse", "grouped", "groupedFirst", "groupedLast", "large", "mono", "noSpacing", "shade", "soft", "primary", "rectangular", "secondary", "shimmer", "short", "small", "transparent", "type", "underlined", "noBorder", "tall", "theme", "css", "href", "noWrap", "shadowLevel", "wide"]);

  return _react.default.createElement("button", _extends({}, props, css(styles.button, !small && !large && styles.button_medium, loading && styles.button_loading, fullWidth && styles.button_fullWidth, block && styles.button_block, compact && styles.button_compact, disabled && styles.button_disabled, inverse && styles.button_inverse, grouped && styles.button_grouped, groupedFirst && styles.button_groupedFirst, groupedLast && styles.button_groupedLast, large && styles.button_large, mono && styles.button_mono, noSpacing && styles.button_noSpacing, soft && styles.button_soft, primary && styles.button_primary, rectangular && styles.button_rectangular, secondary && styles.button_secondary, shade && styles.button_shade, short && styles.button_short, small && styles.button_small, tall && styles.button_tall, transparent && styles.button_transparent, underlined && styles.button_underlined, noBorder && styles.button_noBorder, wide && styles.button_wide), {
    disabled: disabled || loading,
    type: type
  }), loading && shimmer && _react.default.createElement("div", css(styles.shimmer), _react.default.createElement(_Shimmer.default, {
    height: "100%",
    width: "100%"
  })), _react.default.createElement("div", css(styles.button__content, loading && styles.button__content_loading, fullWidth && styles.button__content_fullWidth), children), loading && _react.default.createElement("div", css(styles.button__loader, shimmer && styles.button__loader_shimmer), !shimmer && _react.default.createElement(_Loader.default, {
    small: true,
    primary: inverse && soft,
    secondary: secondary,
    mono: mono
  })));
};

Button.propTypes = propTypes;
Button.defaultProps = defaultProps;
var ButtonWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var button = _ref2.button,
      color = _ref2.color,
      breakpoint = _ref2.breakpoint,
      units = _ref2.units,
      font = _ref2.font,
      fontSize = _ref2.fontSize,
      animation = _ref2.animation,
      radius = _ref2.radius;
  return {
    button: {
      appearance: 'none',
      borderWidth: button.borderWidth,
      backgroundColor: color.secondary,
      height: button.height,
      //minWidth: units(2.5),
      paddingTop: button.verticalPadding,
      paddingRight: button.horizontalPadding,
      paddingBottom: button.verticalPadding,
      paddingLeft: button.horizontalPadding,
      borderRadius: button.radius,
      color: color.white,
      outline: 0,
      position: 'relative',
      marginLeft: button.spacing,
      marginRight: button.spacing,
      marginBottom: button.bottomSpacing,
      fontWeight: button.fontWeight,
      fontFamily: button.fontFamily,
      cursor: 'pointer',
      boxSizing: 'border-box',
      overflow: 'hidden',
      ':hover': {
        backgroundColor: color.secondarySaturated
      },
      ':active': {
        backgroundColor: color.secondaryDarker
      }
    },
    button_soft: {
      backgroundColor: color.blueGrayLighter,
      color: color.primary,
      ':hover': {
        backgroundColor: color.blueGrayLight
      },
      ':active': {
        backgroundColor: color.blueGray
      }
    },
    button_fullWidth: {
      width: '100%'
    },
    button_loading: {
      opacity: 1,
      pointerEvents: 'none'
    },
    button_block: {
      width: '100%',
      textAlign: 'left',
      marginRight: 0,
      marginLeft: 0
    },
    button_compact: {
      paddingRight: button.compactHorizontalPadding,
      paddingLeft: button.compactHorizontalPadding
    },
    button_wide: {
      paddingRight: button.wideHorizontalPadding,
      paddingLeft: button.wideHorizontalPadding
    },
    button_shade: {
      background: color.shadowWeakest,
      ':hover': {
        background: color.shadowWeaker
      },
      ':active': {
        background: color.shadowWeak
      }
    },
    button_short: {
      height: button.shortHeight
    },
    button_tall: {
      height: button.tallHeight
    },
    button_underlined: {
      borderBottomWidth: 1,
      borderBottomColor: color.primary,
      borderBottomStyle: 'solid'
    },
    button_grouped: {
      marginRight: .5,
      marginBottom: 0,
      marginLeft: .5
    },
    button_groupedFirst: {
      borderRadius: "".concat(radius, "px 0 0 ").concat(radius, "px"),
      marginLeft: 0
    },
    button_groupedLast: {
      borderRadius: "0 ".concat(radius, "px ").concat(radius, "px 0"),
      marginRight: 0
    },
    button_disabled: {
      opacity: .5,
      pointerEvents: 'none'
    },
    button_mono: {
      backgroundColor: color.transparent,
      borderColor: color.black,
      borderWidth: 1,
      borderStyle: 'solid',
      color: color.black,
      ':hover': {
        background: 'none'
      },
      ':active': {
        backgroundColor: color.grayLighter
      }
    },
    button_noSpacing: {
      marginBottom: 0
    },
    button_primary: {
      backgroundColor: color.primary,
      ':hover': {
        background: color.primarySaturated
      },
      ':active': {
        background: color.primaryDarker
      }
    },
    button_secondary: {
      backgroundColor: color.transparent,
      borderColor: color.secondary,
      borderWidth: 1,
      borderStyle: 'solid',
      color: color.secondary,
      ':hover': {
        color: color.secondarySaturated,
        backgroundColor: color.grayLightest
      },
      ':active': {
        borderColor: color.secondaryDarker,
        backgroundColor: color.grayLighter
      }
    },
    button_inverse: {
      backgroundColor: color.white,
      color: color.primary,
      borderWidth: 0,
      ':hover': {
        backgroundColor: color.blueGrayLight
      },
      ':active': {
        backgroundColor: color.blueGray
      }
    },
    button_transparent: {
      backgroundColor: color.transparent,
      color: color.primary,
      ':hover': {
        background: color.shadowWeakest
      },
      ':active': {
        background: color.shadowWeaker
      }
    },
    button_rectangular: {
      borderRadius: 0
    },
    button_noBorder: {
      border: 'none',
      borderWidth: 0
    },
    button_small: _defineProperty({
      fontSize: button.smallFontSize
    }, breakpoint.large, {
      fontSize: button.smallFontSizeOnLarge
    }),
    button_large: _defineProperty({
      fontSize: button.largeFontSize
    }, breakpoint.large, {
      fontSize: button.largeFontSizeOnLarge
    }),
    button_medium: _defineProperty({
      fontSize: button.fontSize
    }, breakpoint.large, {
      fontSize: button.fontSizeOnLarge
    }),
    button__content: {
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'flex-start',
      opacity: 1,
      transition: 'opacity .2s',
      whiteSpace: 'nowrap',
      userSelect: 'none'
    },
    button__content_loading: {
      opacity: 0
    },
    button__content_fullWidth: {
      justifyContent: 'center'
    },
    button__loader: {
      position: 'absolute',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0,
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center'
    },
    shimmer: {
      position: 'absolute',
      width: '100%',
      height: '100%',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0
    }
  };
})(Button);
var _default = ButtonWithStyles;
exports.default = _default;