"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactWithStyles = require("react-with-styles");

var _withStyles = require("../helpers/withStyles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread({}, _reactWithStyles.withStylesPropTypes, {
  children: _propTypes.default.any.isRequired,
  disabled: _propTypes.default.bool,
  inline: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  onClick: _propTypes.default.func,
  rectangular: _propTypes.default.bool
});

var Clickable = function Clickable(_ref) {
  var children = _ref.children,
      css = _ref.css,
      disabled = _ref.disabled,
      inline = _ref.inline,
      inverse = _ref.inverse,
      onClick = _ref.onClick,
      rectangular = _ref.rectangular,
      styles = _ref.styles;
  return inline ? _react.default.createElement("span", _extends({
    onClick: onClick
  }, css(styles.clickable, disabled && styles.clickable_disabled, inverse && styles.clickable_inverse, rectangular && styles.clickable_rectangular)), children) : _react.default.createElement("div", _extends({
    onClick: onClick
  }, css(styles.clickable, disabled && styles.clickable_disabled, inverse && styles.clickable_inverse, rectangular && styles.clickable_rectangular)), children);
};

Clickable.propTypes = propTypes;
var ClickableWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var color = _ref2.color,
      radius = _ref2.radius;
  return {
    clickable: {
      cursor: 'pointer',
      borderRadius: radius,
      ':hover': {
        background: color.shadowWeakest
      },
      ':active': {
        background: color.shadowWeaker
      }
    },
    clickable_disabled: {
      pointerEvents: 'none',
      opacity: 0.5
    },
    clickable_inverse: {
      ':hover': {
        background: color.fogWeakest
      },
      ':active': {
        background: color.fogWeaker
      }
    },
    clickable_rectangular: {
      borderRadius: 0
    }
  };
})(Clickable);
var _default = ClickableWithStyles;
exports.default = _default;