"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _withStyles = require("../helpers/withStyles");

var _PageHeader = _interopRequireDefault(require("./PageHeader"));

var _Wrapper = _interopRequireDefault(require("./Wrapper"));

var _Spacing = _interopRequireDefault(require("./Spacing"));

var _Grid = _interopRequireDefault(require("./Grid"));

var _Cell = _interopRequireDefault(require("./Cell"));

var _Text = _interopRequireDefault(require("./Text"));

var _Icon = _interopRequireDefault(require("./Icon"));

var _FlatButton = _interopRequireDefault(require("./FlatButton"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var ConfigurationBox =
/*#__PURE__*/
function (_Component) {
  _inherits(ConfigurationBox, _Component);

  function ConfigurationBox() {
    _classCallCheck(this, ConfigurationBox);

    return _possibleConstructorReturn(this, _getPrototypeOf(ConfigurationBox).apply(this, arguments));
  }

  _createClass(ConfigurationBox, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          actions = _this$props.actions,
          children = _this$props.children,
          closable = _this$props.closable,
          css = _this$props.css,
          description = _this$props.description,
          header = _this$props.header,
          onClose = _this$props.onClose,
          styles = _this$props.styles,
          title = _this$props.title;
      return _react.default.createElement("div", css(styles.configurationBox), _react.default.createElement("div", css(styles.configurationBox__header), _react.default.createElement(_Grid.default, {
        center: true
      }, _react.default.createElement(_Cell.default, {
        auto: true,
        noSpacing: true
      }, _react.default.createElement(_PageHeader.default, {
        title: title,
        description: description,
        level: 2,
        removeMargin: true,
        removeDescriptionSpacing: description != null
      }, actions)), closable && _react.default.createElement(_Cell.default, {
        shrink: true,
        noSpacing: true
      }, _react.default.createElement("div", css(styles.closeButtonContainer), _react.default.createElement(_FlatButton.default, {
        transparent: true,
        icon: _react.default.createElement(_Icon.default, {
          name: "error",
          large: true
        }),
        onClick: function onClick() {
          return onClose && onClose();
        }
      }))))), _react.default.createElement("div", css(styles.configurationBox__body), header && Array.isArray(header) && header.length > 0 && _react.default.createElement("div", css(styles.configurationBox__header), _react.default.createElement(_Grid.default, {
        resetSpacing: true
      }, header.map(function (headerItem, count) {
        return _react.default.createElement(_Cell.default, {
          size: 12,
          key: count,
          shrinkOnMedium: true
        }, _react.default.createElement("div", css(styles.configurationBox__header__item, styles.padded, count + 1 < header.length && styles.borderRight), _react.default.createElement(_Text.default, {
          bold: true
        }, headerItem.label), _react.default.createElement(_Text.default, {
          large: true
        }, headerItem.content)));
      }))), _react.default.createElement(_Spacing.default, {
        top: 2
      }, _react.default.createElement(_Wrapper.default, null, children))));
    }
  }]);

  return ConfigurationBox;
}(_react.Component);

var ConfigurationBoxWithStyles = (0, _withStyles.withStyles)(function (_ref) {
  var color = _ref.color,
      units = _ref.units,
      radius = _ref.radius,
      font = _ref.font,
      breakpoint = _ref.breakpoint;
  return {
    configurationBox: {
      display: 'flex',
      flexDirection: 'column',
      height: '100%',
      fontFamily: font.default
    },
    configurationBox__header: _defineProperty({
      paddingRight: units(1.5),
      paddingLeft: units(1.5),
      borderBottomWidth: 1,
      borderBottomColor: color.blueGrayLight,
      borderBottomStyle: 'solid',
      background: color.white
    }, breakpoint.large, {
      paddingRight: units(3),
      paddingLeft: units(3)
    }),
    configurationBox__header__item: {
      paddingRight: units(2)
    },
    padded: _defineProperty({
      paddingTop: units(.5),
      paddingBottom: units(.5)
    }, breakpoint.mediumAndAbove, {
      paddingTop: units(1),
      paddingBottom: units(1)
    }),
    borderRight: _defineProperty({}, breakpoint.mediumAndAbove, {
      borderRightWidth: 1,
      borderRightColor: color.blueGrayLight,
      borderRightStyle: 'solid'
    }),
    configurationBox__body: {
      flex: 1,
      background: color.blueGrayLightest,
      overflow: 'auto',
      paddingBottom: units(4)
    },
    configurationBox__bullet: {
      width: 6,
      height: 6,
      background: color.grayDarker,
      borderRadius: '50%',
      marginTop: 8
    },
    closeButtonContainer: _defineProperty({
      position: 'absolute',
      right: units(1),
      top: units(1)
    }, breakpoint.mediumAndAbove, {
      position: 'static',
      borderLeftWidth: 1,
      borderLeftColor: color.blueGray,
      borderLeftStyle: 'solid',
      marginLeft: 16,
      paddingLeft: 8
    })
  };
})(ConfigurationBox);
var _default = ConfigurationBoxWithStyles;
exports.default = _default;