"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _Spacing = _interopRequireDefault(require("./Spacing"));

var _Text = _interopRequireDefault(require("./Text"));

var _Title = _interopRequireDefault(require("./Title"));

var _Icon = _interopRequireDefault(require("./Icon"));

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread({}, _reactWithStyles.withStylesPropTypes, {
  after: _propTypes.default.object,
  before: _propTypes.default.object,
  children: _propTypes.default.any.isRequired,
  description: _propTypes.default.string,
  done: _propTypes.default.bool,
  errorMessage: _propTypes.default.string,
  invalid: _propTypes.default.bool,
  title: _propTypes.default.string
});

var ConfigurationItem =
/*#__PURE__*/
function (_Component) {
  _inherits(ConfigurationItem, _Component);

  function ConfigurationItem() {
    _classCallCheck(this, ConfigurationItem);

    return _possibleConstructorReturn(this, _getPrototypeOf(ConfigurationItem).apply(this, arguments));
  }

  _createClass(ConfigurationItem, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          after = _this$props.after,
          before = _this$props.before,
          children = _this$props.children,
          css = _this$props.css,
          description = _this$props.description,
          done = _this$props.done,
          errorMessage = _this$props.errorMessage,
          invalid = _this$props.invalid,
          styles = _this$props.styles,
          title = _this$props.title;
      return _react.default.createElement("div", css(styles.configurationItem), before, _react.default.createElement("div", css(styles.configurationItem__content), _react.default.createElement(_Spacing.default, {
        bottom: 1
      }, _react.default.createElement(_Title.default, {
        noSpacing: true,
        light: true,
        level: 3
      }, title, (done || invalid) && _react.default.createElement("div", css(styles.statusLabel, done && styles.statusLabel_done, invalid && styles.statusLabel_error), _react.default.createElement(_Icon.default, {
        micro: true,
        inverse: true,
        name: done ? 'check' : 'error'
      }))), _react.default.createElement(_Text.default, {
        small: true,
        mutted: true
      }, description)), children, invalid && errorMessage && _react.default.createElement("div", css(styles.errorMessage), _react.default.createElement(_Text.default, {
        error: true
      }, "Mensagem de erro"))), after);
    }
  }]);

  return ConfigurationItem;
}(_react.Component);

var ConfigurationItemWithStyles = (0, _withStyles.withStyles)(function (_ref) {
  var color = _ref.color,
      units = _ref.units,
      radius = _ref.radius,
      font = _ref.font;
  return {
    configurationItem: {
      borderRadius: radius,
      borderWidth: 1,
      borderColor: color.blueGrayLight,
      borderStyle: 'solid',
      background: color.white,
      overflow: 'hidden'
    },
    configurationItem__content: {
      padding: units(1.5)
    },
    statusLabel: {
      width: 16,
      height: 16,
      marginLeft: 8,
      borderRadius: '50%',
      display: 'inline-flex',
      alignItems: 'center',
      justifyContent: 'center'
    },
    statusLabel_done: {
      background: color.success
    },
    statusLabel_error: {
      background: color.alert
    },
    statusLabel__icon: {
      fill: color.white
    },
    errorMessage: {
      background: color.alertLight,
      marginTop: units(1.5),
      marginRight: units(-1.5),
      marginBottom: units(-1.5),
      marginLeft: units(-1.5),
      paddingTop: units(1),
      paddingRight: units(1.5),
      paddingBottom: units(1),
      paddingLeft: units(1.5)
    }
  };
})(ConfigurationItem);
ConfigurationItem.propTypes = propTypes;
var _default = ConfigurationItemWithStyles;
exports.default = _default;