"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Loader = _interopRequireDefault(require("./Loader"));

var _Shimmer = _interopRequireDefault(require("./Shimmer"));

var _Icon = _interopRequireDefault(require("./Icon"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread({}, _reactWithStyles.withStylesPropTypes, {
  disabled: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  icon: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  inverse: _propTypes.default.bool,
  large: _propTypes.default.bool,
  mono: _propTypes.default.bool,
  primary: _propTypes.default.bool,
  secondary: _propTypes.default.bool,
  shimmer: _propTypes.default.bool,
  small: _propTypes.default.bool,
  shadowLevel: _propTypes.default.oneOf([0, 1, 2, 3]),
  soft: _propTypes.default.bool,
  square: _propTypes.default.bool,
  transparent: _propTypes.default.bool,
  children: _propTypes.default.node
});

var defaultProps = {
  shadowLevel: 0
};

var FlatButton = function FlatButton(_ref) {
  var styles = _ref.styles,
      children = _ref.children,
      disabled = _ref.disabled,
      loading = _ref.loading,
      icon = _ref.icon,
      inverse = _ref.inverse,
      mono = _ref.mono,
      soft = _ref.soft,
      primary = _ref.primary,
      secondary = _ref.secondary,
      shimmer = _ref.shimmer,
      transparent = _ref.transparent,
      theme = _ref.theme,
      css = _ref.css,
      href = _ref.href,
      large = _ref.large,
      noWrap = _ref.noWrap,
      shadowLevel = _ref.shadowLevel,
      small = _ref.small,
      props = _objectWithoutProperties(_ref, ["styles", "children", "disabled", "loading", "icon", "inverse", "mono", "soft", "primary", "secondary", "shimmer", "transparent", "theme", "css", "href", "large", "noWrap", "shadowLevel", "small"]);

  return _react.default.createElement("button", _extends({}, props, css(styles.button, loading && styles.button_loading, disabled && styles.button_disabled, inverse && styles.button_inverse, mono && styles.button_mono, small && styles.button_small, soft && styles.button_soft, primary && styles.button_primary, secondary && styles.button_secondary, transparent && styles.button_transparent), {
    disabled: disabled || loading,
    type: "button"
  }), loading && shimmer && _react.default.createElement("div", css(styles.shimmer), _react.default.createElement(_Shimmer.default, {
    height: "100%",
    width: "100%"
  })), _react.default.createElement("div", css(styles.button__content, loading && styles.button__content_loading), typeof icon === 'string' ? _react.default.createElement(_Icon.default, {
    name: icon,
    small: small,
    large: large
  }) : icon), loading && _react.default.createElement("div", css(styles.button__loader), !shimmer && _react.default.createElement(_Loader.default, {
    small: true,
    primary: inverse && soft,
    secondary: secondary,
    mono: mono
  })));
};

FlatButton.propTypes = propTypes;
FlatButton.defaultProps = defaultProps;
var FlatButtonWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var color = _ref2.color,
      units = _ref2.units,
      radius = _ref2.radius,
      font = _ref2.font;
  return {
    button: {
      appearance: 'none',
      borderWidth: 0,
      background: color.secondary,
      height: units(2.5),
      width: units(2.5),
      padding: 0,
      borderRadius: '50%',
      color: color.white,
      fill: color.white,
      outline: 0,
      position: 'relative',
      margin: 0,
      fontWeight: 500,
      fontFamily: font.default,
      cursor: 'pointer',
      boxSizing: 'border-box',
      overflow: 'hidden',
      ':hover': {
        background: color.secondarySaturated
      },
      ':active': {
        background: color.secondaryDarker
      }
    },
    button_small: {
      width: units(1.75),
      height: units(1.75)
    },
    button_soft: {
      background: color.blueGrayLighter,
      color: color.primary,
      fill: color.primary,
      ':hover': {
        background: color.blueGrayLight
      },
      ':active': {
        background: color.blueGray
      }
    },
    button_loading: {
      opacity: 1,
      pointerEvents: 'none'
    },
    button_disabled: {
      opacity: .5,
      pointerEvents: 'none'
    },
    button_mono: {
      background: color.transparent,
      borderColor: color.black,
      borderWidth: 1,
      borderStyle: 'solid',
      color: color.black,
      fill: color.black,
      ':hover': {
        background: 'none'
      },
      ':active': {
        background: color.grayLighter
      }
    },
    button_primary: {
      background: color.primary,
      ':hover': {
        background: color.primarySaturated
      },
      ':active': {
        background: color.primaryDarker
      }
    },
    button_secondary: {
      background: color.transparent,
      borderColor: color.secondary,
      borderWidth: 1,
      borderStyle: 'solid',
      color: color.secondary,
      fill: color.secondary,
      ':hover': {
        color: color.secondarySaturated,
        fill: color.secondarySaturated,
        background: color.grayLightest
      },
      ':active': {
        borderColor: color.secondaryDarker,
        background: color.grayLighter
      }
    },
    button_inverse: {
      background: color.white,
      color: color.primary,
      fill: color.primary,
      borderWidth: 0,
      ':hover': {
        background: color.blueGrayLight
      },
      ':active': {
        background: color.blueGray
      }
    },
    button_transparent: {
      background: color.transparent,
      color: color.primary,
      fill: color.primary,
      ':hover': {
        background: color.shadowWeakest
      },
      ':active': {
        background: color.shadowWeaker
      }
    },
    button_square: {
      borderRadius: radius
    },
    button__content: {
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center',
      opacity: 1,
      transition: 'opacity .2s',
      whiteSpace: 'nowrap',
      userSelect: 'none'
    },
    button__content_loading: {
      opacity: 0
    },
    button__loader: {
      position: 'absolute',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0,
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center'
    },
    shimmer: {
      position: 'absolute',
      width: '100%',
      height: '100%',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0
    }
  };
})(FlatButton);
var _default = FlatButtonWithStyles;
exports.default = _default;