"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _withStyles = require("../helpers/withStyles");

var _IconsLibrary = _interopRequireDefault(require("./IconsLibrary"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread({}, _reactWithStyles.withStylesPropTypes, {
  huge: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  large: _propTypes.default.bool,
  micro: _propTypes.default.bool,
  mono: _propTypes.default.bool,
  muted: _propTypes.default.bool,
  name: _propTypes.default.oneOf(['arrow-left', 'arrow-right', 'auto-location', 'check', 'delete', 'edit', 'error', 'filter', 'infographic', 'import-location', 'location', 'map', 'more', 'search', 'settings', 'users', 'vector']),
  noPadding: _propTypes.default.bool,
  primary: _propTypes.default.bool,
  secondary: _propTypes.default.bool,
  small: _propTypes.default.bool,
  smaller: _propTypes.default.bool,
  text: _propTypes.default.bool
});

var Icon = function Icon(_ref) {
  var css = _ref.css,
      huge = _ref.huge,
      inverse = _ref.inverse,
      large = _ref.large,
      micro = _ref.micro,
      mono = _ref.mono,
      muted = _ref.muted,
      name = _ref.name,
      noPadding = _ref.noPadding,
      primary = _ref.primary,
      secondary = _ref.secondary,
      small = _ref.small,
      smaller = _ref.smaller,
      styles = _ref.styles,
      text = _ref.text;

  var rootIcon = _IconsLibrary.default && _IconsLibrary.default.props.children && Array.isArray(_IconsLibrary.default.props.children) && _IconsLibrary.default.props.children.find(function (child) {
    return child.props && child.props.id === "icon-".concat(name);
  });

  var icon = rootIcon && rootIcon.props && rootIcon.props.children;
  return _react.default.createElement("div", css(styles.icon, noPadding && styles.icon_noPadding), _react.default.createElement("svg", _extends({}, css(styles.icon__svg, huge && styles.icon__svg_huge, inverse && styles.icon__svg_inverse, large && styles.icon__svg_large, micro && styles.icon__svg_micro, mono && styles.icon__svg_mono, muted && styles.icon__svg_muted, primary && styles.icon__svg_primary, secondary && styles.icon__svg_secondary, small && styles.icon__svg_small, smaller && styles.icon__svg_smaller, text && styles.icon__svg_text), {
    viewBox: "0 0 512 512"
  }), icon));
};

Icon.propTypes = propTypes;
var IconWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var color = _ref2.color,
      icon = _ref2.icon;
  return {
    icon: {
      padding: 2,
      height: '100%',
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center'
    },
    icon_noPadding: {
      padding: 0
    },
    icon__svg: {
      fill: icon.defaultColor,
      width: icon.size.default
    },
    icon__svg_muted: {
      fill: color.blueGrayDark
    },
    icon__svg_primary: {
      fill: color.primary
    },
    icon__svg_secondary: {
      fill: color.secondary
    },
    icon__svg_inverse: {
      fill: color.white
    },
    icon__svg_mono: {
      fill: color.black
    },
    icon__svg_text: {
      fill: color.grayDarker
    },
    icon__svg_micro: {
      width: icon.size.micro
    },
    icon__svg_small: {
      width: icon.size.small
    },
    icon__svg_smaller: {
      width: icon.size.smaller
    },
    icon__svg_large: {
      width: icon.size.large
    },
    icon__svg_huge: {
      width: icon.size.huge
    }
  };
})(Icon);
var _default = IconWithStyles;
exports.default = _default;