"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Shimmer = _interopRequireDefault(require("./Shimmer"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread({}, _reactWithStyles.withStylesPropTypes, {
  inline: _propTypes.default.bool,
  inside: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  aspectRatio: _propTypes.default.number,
  rectangular: _propTypes.default.bool,
  source: _propTypes.default.string,
  transparent: _propTypes.default.bool,
  width: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string])
});

var defaultProps = {
  aspectRatio: 1,
  width: '100%'
};

var Image = function Image(_ref) {
  var css = _ref.css,
      inline = _ref.inline,
      inside = _ref.inside,
      loading = _ref.loading,
      aspectRatio = _ref.aspectRatio,
      rectangular = _ref.rectangular,
      source = _ref.source,
      styles = _ref.styles,
      transparent = _ref.transparent,
      width = _ref.width;
  return _react.default.createElement("div", css(styles.container, inline && styles.inline, rectangular ? styles.rectangular : styles.radius, {
    width: width
  }), _react.default.createElement("div", css(styles.image, inside ? styles.image_contain : styles.image_cover, transparent ? styles.transparent : styles.opaque, {
    paddingTop: "".concat(aspectRatio * 100, "%"),
    backgroundImage: source && "url(".concat(source, ")")
  })), loading && _react.default.createElement("div", css(styles.loading), _react.default.createElement(_Shimmer.default, {
    width: "100%",
    height: "100%"
  })));
};

Image.propTypes = propTypes;
Image.defaultProps = defaultProps;
var ImageWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var color = _ref2.color,
      radius = _ref2.radius;
  return {
    container: {
      position: 'relative',
      overflow: 'hidden',
      boxSizing: 'border-box'
    },
    rectangular: {
      borderRadius: 0
    },
    radius: {
      borderRadius: radius
    },
    image: {
      width: '100%',
      backgroundSize: 'cover',
      backgroundPosition: 'center',
      backgroundRepeat: 'no-repeat'
    },
    image_cover: {
      backgroundSize: 'cover'
    },
    image_contain: {
      backgroundSize: 'contain'
    },
    inline: {
      display: 'inline-block'
    },
    loading: {
      position: 'absolute',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0
    },
    opaque: {
      backgroundColor: color.gray
    },
    transparent: {
      backgroundColor: color.transparent
    }
  };
})(Image);
var _default = ImageWithStyles;
exports.default = _default;