"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FormElement = _interopRequireDefault(require("./FormElement"));

var _InputOnly = _interopRequireDefault(require("./InputOnly"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propTypes = {
  actionLink: _propTypes.default.string,
  autoCapitalize: _propTypes.default.bool,
  autoComplete: _propTypes.default.oneOf(['off', 'on']),
  autoCorrect: _propTypes.default.any,
  autoFocus: _propTypes.default.bool,
  book: _propTypes.default.bool,
  borderless: _propTypes.default.bool,
  disabled: _propTypes.default.bool,
  errorMessage: _propTypes.default.any,
  focusBorderless: _propTypes.default.bool,
  hideLabel: _propTypes.default.bool,
  id: _propTypes.default.string,
  inline: _propTypes.default.bool,
  inputRef: _propTypes.default.func,
  invalid: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  label: _propTypes.default.string,
  labelDescription: _propTypes.default.string,
  large: _propTypes.default.bool,
  lightLabel: _propTypes.default.bool,
  mask: _propTypes.default.func,
  maxLength: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  name: _propTypes.default.string.isRequired,
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onClear: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  onKeyDown: _propTypes.default.func,
  placeholder: _propTypes.default.string,
  prefix: _propTypes.default.object,
  prefixSeparator: _propTypes.default.bool,
  readOnly: _propTypes.default.bool,
  refForFocus: _propTypes.default.func,
  removeMargins: _propTypes.default.bool,
  removePrefixSpacing: _propTypes.default.bool,
  removeSuffixSpacing: _propTypes.default.bool,
  showFakeValuePlaceholder: _propTypes.default.bool,
  showOverflowEllipsis: _propTypes.default.bool,
  small: _propTypes.default.bool,
  spellCheck: _propTypes.default.any,
  suffix: _propTypes.default.object,
  suffixSeparator: _propTypes.default.bool,
  suffixText: _propTypes.default.any,
  type: _propTypes.default.string,
  underlineFocus: _propTypes.default.bool,
  value: _propTypes.default.string
};
var defaultProps = {
  autoComplete: 'off',
  type: 'text'
};

var Input = function Input(_ref) {
  var actionLink = _ref.actionLink,
      autoCapitalize = _ref.autoCapitalize,
      autoComplete = _ref.autoComplete,
      autoCorrect = _ref.autoCorrect,
      autoFocus = _ref.autoFocus,
      book = _ref.book,
      borderless = _ref.borderless,
      disabled = _ref.disabled,
      errorMessage = _ref.errorMessage,
      focusBorderless = _ref.focusBorderless,
      hideLabel = _ref.hideLabel,
      id = _ref.id,
      inline = _ref.inline,
      inputRef = _ref.inputRef,
      invalid = _ref.invalid,
      inverse = _ref.inverse,
      label = _ref.label,
      labelDescription = _ref.labelDescription,
      large = _ref.large,
      lightLabel = _ref.lightLabel,
      mask = _ref.mask,
      maxLength = _ref.maxLength,
      name = _ref.name,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onClear = _ref.onClear,
      onFocus = _ref.onFocus,
      onKeyDown = _ref.onKeyDown,
      placeholder = _ref.placeholder,
      prefix = _ref.prefix,
      prefixSeparator = _ref.prefixSeparator,
      readOnly = _ref.readOnly,
      refForFocus = _ref.refForFocus,
      removeMargins = _ref.removeMargins,
      removePrefixSpacing = _ref.removePrefixSpacing,
      removeSuffixSpacing = _ref.removeSuffixSpacing,
      showFakeValuePlaceholder = _ref.showFakeValuePlaceholder,
      showOverflowEllipsis = _ref.showOverflowEllipsis,
      small = _ref.small,
      spellCheck = _ref.spellCheck,
      suffix = _ref.suffix,
      suffixSeparator = _ref.suffixSeparator,
      suffixText = _ref.suffixText,
      type = _ref.type,
      underlineFocus = _ref.underlineFocus,
      value = _ref.value;
  return _react.default.createElement(_FormElement.default, {
    actionLink: actionLink,
    errorMessage: errorMessage,
    hideLabel: hideLabel,
    id: id,
    inline: inline,
    invalid: invalid,
    inverse: inverse,
    label: label,
    labelDescription: labelDescription,
    large: large,
    lightLabel: lightLabel,
    small: small
  }, _react.default.createElement(_InputOnly.default, {
    autoCapitalize: autoCapitalize,
    autoComplete: autoComplete,
    autoCorrect: autoCorrect,
    autoFocus: autoFocus,
    book: book,
    borderless: borderless,
    disabled: disabled,
    focusBorderless: focusBorderless,
    id: id,
    inline: inline,
    inputRef: inputRef,
    invalid: invalid,
    inverse: inverse,
    large: large,
    mask: mask,
    maxLength: maxLength,
    name: name,
    onBlur: onBlur,
    onChange: onChange,
    onClear: onClear,
    onFocus: onFocus,
    onKeyDown: onKeyDown,
    placeholder: placeholder,
    prefix: prefix,
    prefixSeparator: prefixSeparator,
    readOnly: readOnly,
    refForFocus: refForFocus,
    removeMargins: removeMargins,
    removePrefixSpacing: removePrefixSpacing,
    removeSuffixSpacing: removeSuffixSpacing,
    showFakeValuePlaceholder: showFakeValuePlaceholder,
    showOverflowEllipsis: showOverflowEllipsis,
    small: small,
    spellCheck: spellCheck,
    suffix: suffix,
    suffixSeparator: suffixSeparator,
    suffixText: suffixText,
    type: type,
    underlineFocus: underlineFocus,
    value: value
  }));
};

Input.propTypes = propTypes;
Input.defaultProps = defaultProps;
var _default = Input;
exports.default = _default;