"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

var _Blanket = _interopRequireDefault(require("./Blanket"));

var _FlatButton = _interopRequireDefault(require("./FlatButton"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread({}, _reactWithStyles.withStylesPropTypes, {
  children: _propTypes.default.any.isRequired,
  flex: _propTypes.default.bool,
  fullHeight: _propTypes.default.bool,
  fullScreen: _propTypes.default.bool,
  global: _propTypes.default.bool,
  large: _propTypes.default.bool,
  micro: _propTypes.default.bool,
  noPadding: _propTypes.default.bool,
  onClickBlanket: _propTypes.default.func,
  onClose: _propTypes.default.func,
  removeBlanket: _propTypes.default.bool,
  removeCloseButton: _propTypes.default.bool,
  small: _propTypes.default.bool,
  visible: _propTypes.default.bool,
  xlarge: _propTypes.default.bool,
  zIndex: _propTypes.default.number
});

var Modal =
/*#__PURE__*/
function (_Component) {
  _inherits(Modal, _Component);

  function Modal() {
    _classCallCheck(this, Modal);

    return _possibleConstructorReturn(this, _getPrototypeOf(Modal).apply(this, arguments));
  }

  _createClass(Modal, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          css = _this$props.css,
          children = _this$props.children,
          flex = _this$props.flex,
          fullHeight = _this$props.fullHeight,
          fullScreen = _this$props.fullScreen,
          global = _this$props.global,
          large = _this$props.large,
          micro = _this$props.micro,
          noPadding = _this$props.noPadding,
          onClickBlanket = _this$props.onClickBlanket,
          onClose = _this$props.onClose,
          removeBlanket = _this$props.removeBlanket,
          removeCloseButton = _this$props.removeCloseButton,
          small = _this$props.small,
          styles = _this$props.styles,
          visible = _this$props.visible,
          xlarge = _this$props.xlarge,
          zIndex = _this$props.zIndex;
      return visible ? _react.default.createElement(_react.Fragment, null, _react.default.createElement("div", css(styles.container, {
        zIndex: typeof zIndex === 'number' && zIndex
      }), _react.default.createElement("div", css(styles.modal, flex && styles.modal_flex, fullHeight && styles.modal_fullHeight, !fullScreen && !xlarge && !small && !large && !micro && styles.modal_default, fullScreen && styles.modal_fullScreen, micro && styles.modal_micro, small && styles.modal_small, large && styles.modal_large, xlarge && styles.modal_xlarge, noPadding && styles.noPadding), !removeCloseButton && _react.default.createElement("div", css(styles.closeButton), _react.default.createElement(_FlatButton.default, {
        transparent: true,
        icon: "error",
        onClick: function onClick() {
          return onClose && onClose();
        }
      })), children), (removeBlanket || !fullScreen) && _react.default.createElement(_Blanket.default, {
        global: global,
        visible: true,
        onClick: function onClick() {
          return onClickBlanket ? onClickBlanket() : onClose ? onClose() : null;
        }
      }))) : null;
    }
  }]);

  return Modal;
}(_react.Component);

var ModalWithStyles = (0, _withStyles.withStyles)(function (_ref) {
  var breakpoint = _ref.breakpoint,
      color = _ref.color,
      units = _ref.units,
      radius = _ref.radius,
      shadow = _ref.shadow;
  return {
    container: {
      position: 'absolute',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0,
      padding: 0,
      margin: 0,
      height: '100vh',
      width: '100vw',
      overflow: 'auto',
      boxSizing: 'border-box'
    },
    modal: _objectSpread({
      position: 'absolute',
      zIndex: 999,
      background: color.white,
      left: '50%',
      boxSizing: 'border-box',
      transform: 'translate(-50%, 0)',
      width: "calc(100% - ".concat(units(2), "px)"),
      borderRadius: radius,
      borderColor: color.gray,
      borderWidth: 1,
      borderStyle: 'solid',
      padding: units(1.5),
      marginTop: units(1.5)
    }, shadow.level2),
    modal_default: {
      maxWidth: units(30)
    },
    modal_flex: {
      display: 'flex',
      flexDirection: 'column'
    },
    modal_micro: {
      maxWidth: units(18)
    },
    modal_small: {
      maxWidth: units(24)
    },
    modal_large: {
      maxWidth: units(64)
    },
    modal_xlarge: {
      maxWidth: units(96)
    },
    modal_fullScreen: {
      width: 'unset',
      margin: 0,
      top: 0,
      right: 0,
      bottom: 0,
      left: 0,
      transform: 'unset',
      borderRadius: 0,
      border: 0
    },
    modal_fullHeight: _defineProperty({
      minHeight: "calc(100% - ".concat(units(3), "px)")
    }, breakpoint.large, {
      maxHeight: "calc(100% - ".concat(units(3), "px)")
    }),
    closeButton: {
      position: 'absolute',
      top: units(.5),
      right: units(.5)
    },
    noPadding: {
      padding: 0
    }
  };
})(Modal);
Modal.propTypes = propTypes;
var _default = ModalWithStyles;
exports.default = _default;