"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Grid = _interopRequireDefault(require("./Grid"));

var _Cell = _interopRequireDefault(require("./Cell"));

var _Text = _interopRequireDefault(require("./Text"));

var _Title = _interopRequireDefault(require("./Title"));

var _Spacing = _interopRequireDefault(require("./Spacing"));

var _Visibility = _interopRequireDefault(require("./Visibility"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread({}, _reactWithStyles.withStylesPropTypes, {
  children: _propTypes.default.any,
  description: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  inverse: _propTypes.default.bool,
  level: _propTypes.default.oneOf([1, 2, 3]),
  loading: _propTypes.default.bool,
  removeMargin: _propTypes.default.bool,
  section: _propTypes.default.string,
  title: _propTypes.default.string
});

var defaultProps = {
  level: 1,
  title: ''
};

var PageHeader = function PageHeader(_ref) {
  var children = _ref.children,
      css = _ref.css,
      description = _ref.description,
      inverse = _ref.inverse,
      level = _ref.level,
      loading = _ref.loading,
      border = _ref.border,
      removeDescriptionSpacing = _ref.removeDescriptionSpacing,
      removeMargin = _ref.removeMargin,
      section = _ref.section,
      styles = _ref.styles,
      title = _ref.title;
  return _react.default.createElement("div", css(styles.pageHeader, border && styles.pageHeader_withBorder, removeMargin && styles.pageHeader_noMargin), _react.default.createElement(_Grid.default, {
    resetSpacing: true
  }, _react.default.createElement(_Cell.default, {
    size: 12,
    autoOnMedium: true
  }, section && _react.default.createElement(_Text.default, {
    muted: true,
    small: true,
    bold: true
  }, section), _react.default.createElement(_Title.default, {
    title: title,
    level: level,
    noTopSpacing: section != null,
    noBottomSpacing: removeDescriptionSpacing
  }), description && typeof description === 'string' ? _react.default.createElement(_Text.default, {
    loading: loading
  }, description) : description), _react.default.createElement(_Visibility.default, {
    showIf: children !== undefined
  }, _react.default.createElement(_Cell.default, {
    size: 12,
    shrinkOnMedium: true
  }, _react.default.createElement(_Spacing.default, {
    top: 0.5
  }, children)))));
};

PageHeader.propTypes = propTypes;
PageHeader.defaultProps = defaultProps;
var PageHeaderWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var color = _ref2.color,
      units = _ref2.units;
  return {
    pageHeader: {
      paddingTop: units(1),
      paddingBottom: units(1),
      display: 'flex',
      marginBottom: units(1.5)
    },
    pageHeader_withBorder: {
      borderBottomColor: color.blueGray,
      borderBottomWidth: 1,
      borderBottomStyle: 'solid',
      marginBottom: units(2)
    },
    pageHeader_noMargin: {
      marginBottom: 0
    }
  };
})(PageHeader);
var _default = PageHeaderWithStyles;
exports.default = _default;