"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PrivateRoute = void 0;

var _reactRouterDom = require("react-router-dom");

var _reactRedux = require("react-redux");

var _react = _interopRequireWildcard(require("react"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var PrivateRoute =
/*#__PURE__*/
function (_Component) {
  _inherits(PrivateRoute, _Component);

  function PrivateRoute() {
    _classCallCheck(this, PrivateRoute);

    return _possibleConstructorReturn(this, _getPrototypeOf(PrivateRoute).apply(this, arguments));
  }

  _createClass(PrivateRoute, [{
    key: "handleUnauthorizedAccess",
    value: function handleUnauthorizedAccess() {
      console.log(window.location);
      var href = window.location.href;
      return _react.default.createElement(_reactRouterDom.Route, {
        render: function render() {
          return window.location = "http://auth.localcinnecta.com/signin?continue=".concat(href);
        }
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this = this;

      var _this$props = this.props,
          Component = _this$props.component,
          render = _this$props.render,
          authenticated = _this$props.authenticated,
          loading = _this$props.loading,
          location = _this$props.location,
          rest = _objectWithoutProperties(_this$props, ["component", "render", "authenticated", "loading", "location"]);

      if (loading) {
        return _react.default.createElement(_reactRouterDom.Route, _extends({}, rest, {
          component: Loading
        }));
      }

      var renderMethod = render;

      if (render && !authenticated) {
        renderMethod = function renderMethod() {
          return _this.handleUnauthorizedAccess(location);
        };
      }

      return _react.default.createElement(_reactRouterDom.Route, _extends({}, rest, {
        render: render ? renderMethod : function (props) {
          return authenticated ? _react.default.createElement(Component, props) : _this.handleUnauthorizedAccess(location);
        }
      }));
    }
  }]);

  return PrivateRoute;
}(_react.Component);

var Loading = function Loading() {
  return _react.default.createElement("div", null, "Autenticando...");
};

var mapStateToProps = function mapStateToProps(state) {
  var _state$auth = state.auth,
      authenticated = _state$auth.authenticated,
      loading = _state$auth.loading;
  return {
    authenticated: authenticated,
    loading: loading
  };
};

var ConnectedPrivateRoute = (0, _reactRedux.connect)(mapStateToProps)(PrivateRoute);
exports.PrivateRoute = ConnectedPrivateRoute;