"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _airbnbPropTypes = require("airbnb-prop-types");

var _Spacing = _interopRequireDefault(require("./Spacing"));

var _FormElementGroup = _interopRequireDefault(require("./FormElementGroup"));

var _RadioButton = _interopRequireDefault(require("./RadioButton"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propTypes = {
  actionLink: _propTypes.default.any,
  children: (0, _airbnbPropTypes.childrenOfType)(_RadioButton.default),
  collapseSpacing: _propTypes.default.bool,
  errorMessage: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  hideLabel: _propTypes.default.bool,
  id: _propTypes.default.string,
  inline: _propTypes.default.bool,
  invalid: _propTypes.default.bool,
  label: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
  labelDescription: _propTypes.default.string,
  lightLabel: _propTypes.default.bool,
  name: _propTypes.default.string.isRequired,
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  refForFocus: _propTypes.default.func,
  spaceOnLastItem: _propTypes.default.bool,
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object, _propTypes.default.number])
};
var defaultProps = {
  label: ''
};

var RadioButtonGroup = function RadioButtonGroup(_ref) {
  var actionLink = _ref.actionLink,
      children = _ref.children,
      collapseSpacing = _ref.collapseSpacing,
      errorMessage = _ref.errorMessage,
      hideLabel = _ref.hideLabel,
      id = _ref.id,
      inline = _ref.inline,
      invalid = _ref.invalid,
      label = _ref.label,
      labelDescription = _ref.labelDescription,
      lightLabel = _ref.lightLabel,
      name = _ref.name,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      refForFocus = _ref.refForFocus,
      spaceOnLastItem = _ref.spaceOnLastItem,
      value = _ref.value;

  var childrenSize = _react.default.Children.count(children);

  return _react.default.createElement(_FormElementGroup.default, {
    actionLink: actionLink,
    collapseSpacing: collapseSpacing,
    errorMessage: errorMessage,
    hideLabel: hideLabel,
    invalid: invalid,
    label: label,
    labelDescription: labelDescription,
    lightLabel: lightLabel
  }, children && _react.default.Children.map(children, function (child, i) {
    var radioButton = _react.default.cloneElement(child, {
      name: name,
      id: name && "".concat(name.toLowerCase(), "-").concat(i),
      invalid: invalid,
      onBlur: onBlur,
      onChange: onChange,
      onFocus: onFocus,
      checked: child.props.value === value
    });

    return _react.default.createElement(_Spacing.default, {
      inline: inline,
      right: inline && 2,
      bottom: !inline && i + 1 === childrenSize && !spaceOnLastItem ? 0 : 0.5
    }, radioButton);
  }));
};

RadioButtonGroup.propTypes = propTypes;
RadioButtonGroup.defaultProps = defaultProps;
var _default = RadioButtonGroup;
exports.default = _default;