"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.withBreakpoints = exports.Responsive = exports.ResponsiveConsumer = exports.ResponsiveWrapper = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _breakpoints = require("../helpers/breakpoints");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var initialBreakpoint = {
  name: 'default',
  value: 0
};

var _React$createContext = _react.default.createContext(initialBreakpoint),
    Provider = _React$createContext.Provider,
    Consumer = _React$createContext.Consumer;

var ResponsiveConsumer = Consumer;
exports.ResponsiveConsumer = ResponsiveConsumer;

var withBreakpoints = function withBreakpoints(Comp) {
  return function (props) {
    return _react.default.createElement(ResponsiveConsumer, null, function (breakpoint) {
      return _react.default.createElement(Comp, _extends({
        breakpoint: breakpoint,
        isGreaterThan: function isGreaterThan(value) {
          return breakpointIsGreaterThan(value, breakpoint.value);
        },
        isLessThan: function isLessThan(value) {
          return breakpointIsLessThan(value, breakpoint.value);
        }
      }, props));
    });
  };
};

exports.withBreakpoints = withBreakpoints;

var ResponsiveWrapper =
/*#__PURE__*/
function (_Component) {
  _inherits(ResponsiveWrapper, _Component);

  function ResponsiveWrapper(props) {
    var _this;

    _classCallCheck(this, ResponsiveWrapper);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ResponsiveWrapper).call(this, props));
    _this.state = _objectSpread({}, initialBreakpoint);
    _this.mediaQueries = [];
    return _this;
  }

  _createClass(ResponsiveWrapper, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      this.mediaQueries = Object.keys(_breakpoints.breakpoints).map(function (key) {
        var query = window.matchMedia("(min-width: ".concat(_breakpoints.breakpoints[key], "px)"));
        query.breakpoint = _breakpoints.breakpoints[key];
        query.name = key;
        query.addListener(function () {
          return _this2.dispatchActiveQuery();
        });
        return query;
      });
      this.dispatchActiveQuery();
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      var _this3 = this;

      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = this.mediaQueries[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var query = _step.value;
          query.removeListener(function () {
            return _this3.dispatchActiveQuery();
          });
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return != null) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }
    }
  }, {
    key: "dispatchActiveQuery",
    value: function dispatchActiveQuery() {
      var activeQuery = this.mediaQueries.reduce(function (prev, curr) {
        return curr.matches ? curr : prev && prev.matches ? prev : null;
      });
      var breakpointName = activeQuery ? activeQuery.name : 'default';
      var breakpointSize = activeQuery && activeQuery.breakpoint;
      this.setState({
        name: breakpointName,
        value: breakpointSize
      });
    }
  }, {
    key: "render",
    value: function render() {
      return _react.default.createElement(Provider, {
        value: _objectSpread({}, this.state)
      }, _react.default.createElement(_react.Fragment, null, this.props.children));
    }
  }]);

  return ResponsiveWrapper;
}(_react.Component);

exports.ResponsiveWrapper = ResponsiveWrapper;
var propTypes = {
  unmount: _propTypes.default.bool,
  showFor: _propTypes.default.oneOf(['small', 'medium', 'large', 'xlarge']),
  hideFor: _propTypes.default.oneOf(['small', 'medium', 'large', 'xlarge']),
  children: _propTypes.default.any
};

var Responsive =
/*#__PURE__*/
function (_Component2) {
  _inherits(Responsive, _Component2);

  function Responsive() {
    _classCallCheck(this, Responsive);

    return _possibleConstructorReturn(this, _getPrototypeOf(Responsive).apply(this, arguments));
  }

  _createClass(Responsive, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          unmount = _this$props.unmount,
          showFor = _this$props.showFor,
          hideFor = _this$props.hideFor,
          children = _this$props.children;

      var content = function content(breakpoint) {
        if (showFor && breakpointIsLessThan(showFor, breakpoint.value) || hideFor && breakpointIsGreaterThan(hideFor, breakpoint.value)) {
          if (unmount) {
            return null;
          } else {
            return _react.default.createElement("div", {
              style: {
                display: 'none'
              }
            }, children);
          }
        } else {
          return children;
        }
      };

      return _react.default.createElement(Consumer, null, function (breakpoint) {
        return content(breakpoint);
      });
    }
  }]);

  return Responsive;
}(_react.Component);

exports.Responsive = Responsive;
Responsive.propTypes = propTypes;

var breakpointIsGreaterThan = function breakpointIsGreaterThan(breakpointToCompare, currentBreakpointSize) {
  var comparison = typeof breakpointToCompare === 'string' ? _breakpoints.breakpoints[breakpointToCompare] : breakpointToCompare;
  return currentBreakpointSize === null || currentBreakpointSize >= comparison;
};

var breakpointIsLessThan = function breakpointIsLessThan(breakpointToCompare, currentBreakpointSize) {
  var comparison = typeof breakpointToCompare === 'string' ? _breakpoints.breakpoints[breakpointToCompare] : breakpointToCompare;
  return currentBreakpointSize !== null && currentBreakpointSize < comparison;
};