"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FormElement = _interopRequireDefault(require("./FormElement"));

var _SelectOnly = _interopRequireDefault(require("./SelectOnly"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propTypes = {
  actionLink: _propTypes.default.string,
  autoCapitalize: _propTypes.default.bool,
  autoComplete: _propTypes.default.oneOf(['off', 'on']),
  autoCorrect: _propTypes.default.any,
  autoFocus: _propTypes.default.bool,
  book: _propTypes.default.bool,
  borderless: _propTypes.default.bool,
  cacheOptions: _propTypes.default.bool,
  clearable: _propTypes.default.bool,
  closeMenuOnSelect: _propTypes.default.bool,
  defaultOptions: _propTypes.default.oneOfType([_propTypes.default.bool, _propTypes.default.array]),
  defaultValue: _propTypes.default.object,
  disabled: _propTypes.default.bool,
  errorMessage: _propTypes.default.any,
  focusBorderless: _propTypes.default.bool,
  getOptionLabel: _propTypes.default.func,
  getOptionValue: _propTypes.default.func,
  hideLabel: _propTypes.default.bool,
  id: _propTypes.default.string,
  inline: _propTypes.default.bool,
  inputRef: _propTypes.default.func,
  invalid: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  label: _propTypes.default.string,
  labelDescription: _propTypes.default.string,
  large: _propTypes.default.bool,
  lightLabel: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  loadingMessage: _propTypes.default.string,
  loadOptions: _propTypes.default.func,
  mask: _propTypes.default.func,
  maxLength: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  multiple: _propTypes.default.bool,
  name: _propTypes.default.string.isRequired,
  noOptionsMessage: _propTypes.default.string,
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onClear: _propTypes.default.func,
  onCreateOption: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  onInputChange: _propTypes.default.func,
  onKeyDown: _propTypes.default.func,
  options: _propTypes.default.array,
  placeholder: _propTypes.default.string,
  prefix: _propTypes.default.object,
  prefixSeparator: _propTypes.default.bool,
  readOnly: _propTypes.default.bool,
  refForFocus: _propTypes.default.func,
  removeMargins: _propTypes.default.bool,
  removePrefixSpacing: _propTypes.default.bool,
  removeSuffixSpacing: _propTypes.default.bool,
  shimmer: _propTypes.default.bool,
  showFakeValuePlaceholder: _propTypes.default.bool,
  showOverflowEllipsis: _propTypes.default.bool,
  small: _propTypes.default.bool,
  spellCheck: _propTypes.default.any,
  suffix: _propTypes.default.object,
  suffixSeparator: _propTypes.default.bool,
  suffixText: _propTypes.default.any,
  type: _propTypes.default.string,
  underlineFocus: _propTypes.default.bool,
  value: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.array, _propTypes.default.object])
};
var defaultProps = {
  autoComplete: 'off',
  type: 'text',
  closeMenuOnSelect: true
};

var Select = function Select(_ref) {
  var actionLink = _ref.actionLink,
      autoCapitalize = _ref.autoCapitalize,
      autoComplete = _ref.autoComplete,
      autoCorrect = _ref.autoCorrect,
      autoFocus = _ref.autoFocus,
      book = _ref.book,
      borderless = _ref.borderless,
      cacheOptions = _ref.cacheOptions,
      clearable = _ref.clearable,
      closeMenuOnSelect = _ref.closeMenuOnSelect,
      defaultOptions = _ref.defaultOptions,
      defaultValue = _ref.defaultValue,
      disabled = _ref.disabled,
      errorMessage = _ref.errorMessage,
      focusBorderless = _ref.focusBorderless,
      getOptionLabel = _ref.getOptionLabel,
      getOptionValue = _ref.getOptionValue,
      hideLabel = _ref.hideLabel,
      id = _ref.id,
      inline = _ref.inline,
      inputRef = _ref.inputRef,
      invalid = _ref.invalid,
      inverse = _ref.inverse,
      label = _ref.label,
      labelDescription = _ref.labelDescription,
      large = _ref.large,
      lightLabel = _ref.lightLabel,
      loading = _ref.loading,
      loadingMessage = _ref.loadingMessage,
      loadOptions = _ref.loadOptions,
      mask = _ref.mask,
      maxLength = _ref.maxLength,
      multiple = _ref.multiple,
      name = _ref.name,
      noOptionsMessage = _ref.noOptionsMessage,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onClear = _ref.onClear,
      onCreateOption = _ref.onCreateOption,
      onFocus = _ref.onFocus,
      onInputChange = _ref.onInputChange,
      onKeyDown = _ref.onKeyDown,
      options = _ref.options,
      placeholder = _ref.placeholder,
      prefix = _ref.prefix,
      prefixSeparator = _ref.prefixSeparator,
      readOnly = _ref.readOnly,
      refForFocus = _ref.refForFocus,
      removeMargins = _ref.removeMargins,
      removePrefixSpacing = _ref.removePrefixSpacing,
      removeSuffixSpacing = _ref.removeSuffixSpacing,
      shimmer = _ref.shimmer,
      showFakeValuePlaceholder = _ref.showFakeValuePlaceholder,
      showOverflowEllipsis = _ref.showOverflowEllipsis,
      small = _ref.small,
      spellCheck = _ref.spellCheck,
      suffix = _ref.suffix,
      suffixSeparator = _ref.suffixSeparator,
      suffixText = _ref.suffixText,
      type = _ref.type,
      underlineFocus = _ref.underlineFocus,
      value = _ref.value;
  return _react.default.createElement(_FormElement.default, {
    actionLink: actionLink,
    errorMessage: errorMessage,
    hideLabel: hideLabel,
    id: id,
    inline: inline,
    invalid: invalid,
    inverse: inverse,
    label: label,
    labelDescription: labelDescription,
    large: large,
    lightLabel: lightLabel,
    small: small
  }, _react.default.createElement(_SelectOnly.default, {
    autoCapitalize: autoCapitalize,
    autoComplete: autoComplete,
    autoCorrect: autoCorrect,
    autoFocus: autoFocus,
    book: book,
    borderless: borderless,
    cacheOptions: cacheOptions,
    clearable: clearable,
    closeMenuOnSelect: closeMenuOnSelect,
    defaultOptions: defaultOptions,
    defaultValue: defaultValue,
    disabled: disabled,
    focusBorderless: focusBorderless,
    getOptionLabel: getOptionLabel,
    getOptionValue: getOptionValue,
    id: id,
    inline: inline,
    inputRef: inputRef,
    invalid: invalid,
    inverse: inverse,
    large: large,
    loading: loading,
    loadingMessage: loadingMessage,
    loadOptions: loadOptions,
    mask: mask,
    maxLength: maxLength,
    multiple: multiple,
    name: name,
    noOptionsMessage: noOptionsMessage,
    onBlur: onBlur,
    onChange: onChange,
    onClear: onClear,
    onCreateOption: onCreateOption,
    onFocus: onFocus,
    onInputChange: onInputChange,
    onKeyDown: onKeyDown,
    options: options,
    placeholder: placeholder,
    prefix: prefix,
    prefixSeparator: prefixSeparator,
    readOnly: readOnly,
    refForFocus: refForFocus,
    removeMargins: removeMargins,
    removePrefixSpacing: removePrefixSpacing,
    removeSuffixSpacing: removeSuffixSpacing,
    shimmer: shimmer,
    showFakeValuePlaceholder: showFakeValuePlaceholder,
    showOverflowEllipsis: showOverflowEllipsis,
    small: small,
    spellCheck: spellCheck,
    suffix: suffix,
    suffixSeparator: suffixSeparator,
    suffixText: suffixText,
    type: type,
    underlineFocus: underlineFocus,
    value: value
  }));
};

Select.propTypes = propTypes;
Select.defaultProps = defaultProps;
var _default = Select;
exports.default = _default;