"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _withStyles = require("../helpers/withStyles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Separator = function Separator(_ref) {
  var children = _ref.children,
      css = _ref.css,
      largeSpacing = _ref.largeSpacing,
      noSpacing = _ref.noSpacing,
      smallSpacing = _ref.smallSpacing,
      styles = _ref.styles,
      vertical = _ref.vertical;
  return _react.default.createElement("div", css(styles.separator, vertical ? styles.separator_vertical : styles.separator_horizontal, !vertical && smallSpacing && styles.separator_horizontal_smallSpacing, noSpacing && styles.separator_noSpacing), _react.default.createElement("div", css(styles.separator__line)), children && _react.default.createElement("div", css(styles.separator__content), children), _react.default.createElement("div", css(styles.separator__line)));
};

var SeparatorWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var color = _ref2.color,
      units = _ref2.units;
  return {
    separator: {
      display: 'flex',
      alignItems: 'center',
      color: color.grayDark
    },
    separator_horizontal: {
      flexDirection: 'row',
      width: '100%',
      marginTop: units(2),
      marginBottom: units(2)
    },
    separator_noSpacing: {
      marginTop: 0,
      marginRight: 0,
      marginBottom: 0,
      marginLeft: 0
    },
    separator_horizontal_smallSpacing: {
      marginTop: units(1),
      marginBottom: units(1)
    },
    separator_horizontal_largeSpacing: {
      marginTop: units(3),
      marginBottom: units(3)
    },
    separator__line: {
      flex: 1,
      borderBottomWidth: 1,
      borderBottomStyle: 'solid',
      borderBottomColor: color.gray
    },
    separator__content: {
      paddingLeft: units(1),
      paddingRight: units(1)
    }
  };
})(Separator);
var _default = SeparatorWithStyles;
exports.default = _default;