"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread({}, _reactWithStyles.withStylesPropTypes, {
  height: _propTypes.default.string,
  width: _propTypes.default.string,
  block: _propTypes.default.bool
});

var Shimmer = function Shimmer(_ref) {
  var height = _ref.height,
      width = _ref.width,
      block = _ref.block,
      styles = _ref.styles;
  return _react.default.createElement("span", _extends({}, (0, _withStyles.css)(styles.shimmer, block && styles.shimmer_block), {
    "aria-busy": "true",
    style: {
      height: height,
      width: width
    }
  }));
};

Shimmer.propTypes = propTypes;
var ShimmerWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var color = _ref2.color,
      animation = _ref2.animation;
  return {
    shimmer: {
      backgroundColor: color.shimmer.from,
      display: 'inline-block',
      position: 'relative',
      animationDirection: 'alternate',
      animationDuration: '1s',
      animationFillMode: 'forwards',
      animationIterationCount: 'infinite',
      animationName: animation.shimmer,
      animationTimingFunction: 'ease-in-out'
    },
    shimmer_block: {
      display: 'block'
    }
  };
})(Shimmer);
var _default = ShimmerWithStyles;
exports.default = _default;