"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _CinnectaTheme = _interopRequireDefault(require("../themes/CinnectaTheme"));

var _Responsive = require("./Responsive");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var propTypes = {
  bottom: _propTypes.default.number,
  bottomLargeAndAbove: _propTypes.default.number,
  bottomMediumAndAbove: _propTypes.default.number,
  children: _propTypes.default.any,
  horizontal: _propTypes.default.number,
  horizontalLargeAndAbove: _propTypes.default.number,
  horizontalMediumAndAbove: _propTypes.default.number,
  inline: _propTypes.default.bool,
  inside: _propTypes.default.bool,
  left: _propTypes.default.number,
  leftLargeAndAbove: _propTypes.default.number,
  leftMediumAndAbove: _propTypes.default.number,
  right: _propTypes.default.number,
  rightLargeAndAbove: _propTypes.default.number,
  rightMediumAndAbove: _propTypes.default.number,
  top: _propTypes.default.number,
  topLargeAndAbove: _propTypes.default.number,
  topMediumAndAbove: _propTypes.default.number,
  vertical: _propTypes.default.number,
  verticalLargeAndAbove: _propTypes.default.number,
  verticalMediumAndAbove: _propTypes.default.number,
  isGreaterThan: _propTypes.default.func
};

var Spacing =
/*#__PURE__*/
function (_Component) {
  _inherits(Spacing, _Component);

  function Spacing() {
    _classCallCheck(this, Spacing);

    return _possibleConstructorReturn(this, _getPrototypeOf(Spacing).apply(this, arguments));
  }

  _createClass(Spacing, [{
    key: "render",
    value: function render() {
      var _css, _css2;

      var _this$props = this.props,
          bottom = _this$props.bottom,
          bottomLargeAndAbove = _this$props.bottomLargeAndAbove,
          bottomMediumAndAbove = _this$props.bottomMediumAndAbove,
          children = _this$props.children,
          horizontal = _this$props.horizontal,
          horizontalLargeAndAbove = _this$props.horizontalLargeAndAbove,
          horizontalMediumAndAbove = _this$props.horizontalMediumAndAbove,
          inline = _this$props.inline,
          inside = _this$props.inside,
          left = _this$props.left,
          leftLargeAndAbove = _this$props.leftLargeAndAbove,
          leftMediumAndAbove = _this$props.leftMediumAndAbove,
          right = _this$props.right,
          rightLargeAndAbove = _this$props.rightLargeAndAbove,
          rightMediumAndAbove = _this$props.rightMediumAndAbove,
          top = _this$props.top,
          topLargeAndAbove = _this$props.topLargeAndAbove,
          topMediumAndAbove = _this$props.topMediumAndAbove,
          vertical = _this$props.vertical,
          verticalLargeAndAbove = _this$props.verticalLargeAndAbove,
          verticalMediumAndAbove = _this$props.verticalMediumAndAbove,
          isGreaterThan = _this$props.isGreaterThan;

      var getTopMargin = function getTopMargin() {
        if ((topLargeAndAbove != null || verticalLargeAndAbove != null) && isGreaterThan('large')) {
          return topLargeAndAbove || verticalLargeAndAbove;
        } else if ((topMediumAndAbove != null || verticalMediumAndAbove != null) && isGreaterThan('medium')) {
          return topMediumAndAbove || verticalMediumAndAbove;
        } else {
          return top || vertical;
        }
      };

      var getRightMargin = function getRightMargin() {
        if ((rightLargeAndAbove != null || horizontalLargeAndAbove != null) && isGreaterThan('large')) {
          return rightLargeAndAbove || horizontalLargeAndAbove;
        } else if ((rightMediumAndAbove != null || horizontalMediumAndAbove != null) && isGreaterThan('medium')) {
          return rightMediumAndAbove || horizontalMediumAndAbove;
        } else {
          return right || horizontal;
        }
      };

      var getBottomMargin = function getBottomMargin() {
        if ((bottomLargeAndAbove != null || verticalLargeAndAbove != null) && isGreaterThan('large')) {
          return bottomLargeAndAbove || verticalLargeAndAbove;
        } else if ((bottomMediumAndAbove != null || verticalMediumAndAbove != null) && isGreaterThan('medium')) {
          return bottomMediumAndAbove || verticalMediumAndAbove;
        } else {
          return bottom || vertical;
        }
      };

      var getLeftMargin = function getLeftMargin() {
        if ((leftLargeAndAbove != null || horizontalLargeAndAbove != null) && isGreaterThan('large')) {
          return leftLargeAndAbove || horizontalLargeAndAbove;
        } else if ((leftMediumAndAbove != null || horizontalMediumAndAbove != null) && isGreaterThan('medium')) {
          return leftMediumAndAbove || horizontalMediumAndAbove;
        } else {
          return left || horizontal;
        }
      };

      var topMargin = getTopMargin();
      var rightMargin = getRightMargin();
      var bottomMargin = getBottomMargin();
      var leftMargin = getLeftMargin();
      return inline ? _react.default.createElement("span", (0, _withStyles.css)((_css = {}, _defineProperty(_css, inside ? 'paddingTop' : 'marginTop', topMargin ? topMargin * _CinnectaTheme.default.unit : null), _defineProperty(_css, inside ? 'paddingRight' : 'marginRight', rightMargin ? rightMargin * _CinnectaTheme.default.unit : null), _defineProperty(_css, inside ? 'paddingBottom' : 'marginBottom', bottomMargin ? bottomMargin * _CinnectaTheme.default.unit : null), _defineProperty(_css, inside ? 'paddingLeft' : 'marginLeft', leftMargin ? leftMargin * _CinnectaTheme.default.unit : null), _defineProperty(_css, "display", 'inline-block'), _css)), children) : _react.default.createElement("div", (0, _withStyles.css)((_css2 = {}, _defineProperty(_css2, inside ? 'paddingTop' : 'marginTop', topMargin ? topMargin * _CinnectaTheme.default.unit : null), _defineProperty(_css2, inside ? 'paddingRight' : 'marginRight', rightMargin ? rightMargin * _CinnectaTheme.default.unit : null), _defineProperty(_css2, inside ? 'paddingBottom' : 'marginBottom', bottomMargin ? bottomMargin * _CinnectaTheme.default.unit : null), _defineProperty(_css2, inside ? 'paddingLeft' : 'marginLeft', leftMargin ? leftMargin * _CinnectaTheme.default.unit : null), _defineProperty(_css2, "width", '100%'), _css2)), children);
    }
  }]);

  return Spacing;
}(_react.Component);

Spacing.propTypes = propTypes;
var SpacingWithBreakpoints = (0, _Responsive.withBreakpoints)(Spacing);
var _default = SpacingWithBreakpoints;
exports.default = _default;