"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _Text = _interopRequireDefault(require("./Text"));

var _Shimmer = _interopRequireDefault(require("./Shimmer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propTypes = {
  color: _propTypes.default.string,
  loading: _propTypes.default.bool,
  text: _propTypes.default.string
};

var StatusIndicator = function StatusIndicator(_ref) {
  var text = _ref.text,
      color = _ref.color,
      css = _ref.css,
      loading = _ref.loading,
      styles = _ref.styles;
  return _react.default.createElement("span", css(styles.label), _react.default.createElement("div", css(styles.label__color, {
    backgroundColor: color
  }), loading && _react.default.createElement("div", css(styles.label__color__shimmer), _react.default.createElement(_Shimmer.default, {
    width: "100%",
    height: "100%"
  }))), _react.default.createElement(_Text.default, {
    small: true,
    shimmerWidth: "3rem",
    loading: loading
  }, text));
};

StatusIndicator.propTypes = propTypes;
var StatusIndicatorWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var color = _ref2.color,
      animation = _ref2.animation,
      units = _ref2.units;
  return {
    label: {
      display: 'flex',
      alignItems: 'center',
      flexShrink: 0
    },
    label__color: {
      //backgroundColor: color.blueGrayDark,
      width: units(.625),
      height: units(.625),
      borderRadius: '50%',
      marginRight: units(0.5),
      flexShrink: 0,
      position: 'relative',
      overflow: 'hidden'
    },
    label__color__shimmer: {
      display: 'flex',
      position: 'absolute',
      width: '100%',
      height: '100%',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0
    }
  };
})(StatusIndicator);
var _default = StatusIndicatorWithStyles;
exports.default = _default;