"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash"));

var _moment = _interopRequireDefault(require("moment"));

var _Dropdown = _interopRequireDefault(require("./Dropdown"));

var _Grid = _interopRequireDefault(require("./Grid"));

var _Cell = _interopRequireDefault(require("./Cell"));

var _Responsive = require("./Responsive");

var _Visibility = _interopRequireDefault(require("./Visibility"));

var _CheckboxOnly = _interopRequireDefault(require("./CheckboxOnly"));

var _InputOnly = _interopRequireDefault(require("./InputOnly"));

var _ThrottledTextInput = _interopRequireDefault(require("./ThrottledTextInput"));

var _Icon = _interopRequireDefault(require("./Icon"));

var _Text = _interopRequireDefault(require("./Text"));

var _Spacing = _interopRequireDefault(require("./Spacing"));

var _SummaryItem = _interopRequireDefault(require("./SummaryItem"));

var _withStyles = require("../helpers/withStyles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var propTypes = {
  data: _propTypes.default.array.isRequired,
  loading: _propTypes.default.bool,
  dateFormat: _propTypes.default.string,
  divided: _propTypes.default.bool,
  searchPlaceholder: _propTypes.default.string,
  maxResults: _propTypes.default.number,
  noResultComponent: _propTypes.default.object,
  customActions: _propTypes.default.any,
  sortOptions: _propTypes.default.arrayOf(_propTypes.default.objectOf(_propTypes.default.string)),
  filterFor: _propTypes.default.arrayOf(_propTypes.default.oneOf(['title', 'description'])),
  clean: _propTypes.default.bool,
  onItemAction: _propTypes.default.func,
  paginate: _propTypes.default.bool,
  icons: _propTypes.default.arrayOf(_propTypes.default.string),
  withFilter: _propTypes.default.bool,
  sortable: _propTypes.default.bool,
  selectableItems: _propTypes.default.bool
};
var defaultProps = {
  data: [],
  dateFormat: 'YYYY-MM-DD hh:mm:ss',
  maxResults: 0,
  noResultComponent: _react.default.createElement(_Text.default, null, "Nenhum resultado..."),
  searchPlaceholder: 'buscar...',
  sortOptions: [{
    label: 'Data de criação',
    value: 'createdAt'
  }, {
    label: 'Última atualização',
    value: 'updatedAt'
  }, {
    label: 'Título',
    value: 'title'
  }],
  filterFor: ['title', 'description']
};

var SummaryList =
/*#__PURE__*/
function (_Component) {
  _inherits(SummaryList, _Component);

  function SummaryList(props) {
    var _this;

    _classCallCheck(this, SummaryList);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SummaryList).call(this, props));
    _this.state = {
      checked: [],
      sort: props.sortOptions ? props.sortOptions[0] : null,
      filterString: ''
    };
    return _this;
  }

  _createClass(SummaryList, [{
    key: "filterList",
    value: function filterList(data) {
      var _this$props = this.props,
          filterFor = _this$props.filterFor,
          withFilter = _this$props.withFilter;
      var filterString = this.state.filterString;

      if (withFilter && Array.isArray(filterFor) && filterFor.length > 0 && filterString.length > 2) {
        return data.filter(function (item) {
          return filterFor.some(function (filter) {
            try {
              return item[filter].toLowerCase().search(filterString.toLowerCase()) !== -1;
            } catch (e) {
              return false;
            }
          });
        });
      }

      return data;
    }
  }, {
    key: "sortList",
    value: function sortList(data) {
      var _this2 = this;

      var sort = this.state.sort;

      if (sort.value && data && Array.isArray(data) && data.length > 0 && data[0][sort.value] != null) {
        var isTime = (0, _moment.default)(data[0][sort.value], this.props.dateFormat).isValid();
        return _lodash.default.orderBy(data, function (item) {
          return isTime ? (0, _moment.default)(item[sort.value], _this2.props.dateFormat).valueOf() : item[sort.value];
        }, isTime ? ['desc'] : ['asc']);
      }

      return data;
    }
  }, {
    key: "toggleItem",
    value: function toggleItem(id) {
      var checked = _toConsumableArray(this.state.checked);

      if (checked.includes(id)) {
        checked.splice(id, 1);
      } else {
        checked.push(id);
      }

      this.setState({
        checked: checked
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props2 = this.props,
          data = _this$props2.data,
          loading = _this$props2.loading,
          divided = _this$props2.divided,
          searchPlaceholder = _this$props2.searchPlaceholder,
          noResultComponent = _this$props2.noResultComponent,
          maxResults = _this$props2.maxResults,
          customActions = _this$props2.customActions,
          sortOptions = _this$props2.sortOptions,
          clean = _this$props2.clean,
          paginate = _this$props2.paginate,
          onItemAction = _this$props2.onItemAction,
          icons = _this$props2.icons,
          withFilter = _this$props2.withFilter,
          selectableItems = _this$props2.selectableItems,
          sortable = _this$props2.sortable,
          styles = _this$props2.styles,
          css = _this$props2.css;
      var checked = this.state.checked;
      var listPlaceholder = loading ? _react.default.createElement(_react.Fragment, null, _toConsumableArray(Array(maxResults ? maxResults : 10)).map(function (e, i) {
        return _react.default.createElement(_SummaryItem.default, {
          divided: divided,
          key: i,
          loading: true
        });
      })) : _react.default.createElement("div", null, noResultComponent);
      return _react.default.createElement("div", css(styles.summaryList, clean && styles.summaryList_clean, checked.length > 0 && styles.summaryList_edit), (withFilter || sortable || selectableItems) && _react.default.createElement("div", css(styles.summaryList__header), _react.default.createElement(_Grid.default, {
        resetSpacing: true
      }, selectableItems && _react.default.createElement(_Cell.default, {
        shrink: true
      }, _react.default.createElement(_CheckboxOnly.default, null)), withFilter && _react.default.createElement(_Responsive.Responsive, {
        showFor: "large"
      }, _react.default.createElement(_Cell.default, {
        auto: true
      }, _react.default.createElement("div", css(styles.summaryList__header__filter), _react.default.createElement(_ThrottledTextInput.default, {
        debouncedOnChange: function debouncedOnChange(value) {
          return _this3.setState({
            filterString: value
          });
        },
        debounceTimeoutMs: 500
      }, _react.default.createElement(_InputOnly.default, {
        name: "filterInput",
        placeholder: searchPlaceholder,
        shimmer: loading,
        prefix: _react.default.createElement(_Icon.default, {
          name: "search"
        }),
        removeMargins: true
      }))))), customActions && _react.default.createElement(_Responsive.Responsive, {
        showFor: "large"
      }, _react.default.createElement(_Cell.default, {
        shrink: true
      }, customActions)), sortable && _react.default.createElement(_Cell.default, {
        shrink: true
      }, _react.default.createElement("span", null, _react.default.createElement(_Text.default, {
        small: true,
        inline: true,
        loading: loading
      }, "Ordernar por:"), _react.default.createElement(_Spacing.default, {
        left: .1,
        inline: true
      }, _react.default.createElement(_Dropdown.default, {
        button: true,
        label: this.state.sort && this.state.sort.label,
        options: sortOptions,
        onSelectOption: function onSelectOption(value) {
          return _this3.setState({
            sort: value
          });
        },
        shimmer: loading,
        loading: loading,
        closeOnSelect: true,
        inverse: true,
        compact: true,
        noSpacing: true
      })))))), _react.default.createElement("ul", css(styles.summaryList__list), data.length < 1 ? listPlaceholder : this.sortList(this.filterList(data)).map(function (item) {
        if (item) {
          return _react.default.createElement(_SummaryItem.default, {
            key: item.id,
            item: loading ? {} : item,
            clean: clean,
            divided: divided,
            checked: checked.includes(item.id),
            onAction: function onAction(action) {
              return onItemAction(action, item.id);
            },
            onChange: function onChange() {
              return _this3.toggleItem(item.id);
            },
            loading: loading,
            selectable: selectableItems
          }, _react.default.createElement(_react.Fragment, null, item.custom, icons && !item.custom ? _react.default.createElement(_react.Fragment, null, item.icons.map(function (icon) {
            return _react.default.createElement("i", {
              className: "icon-".concat(icon),
              key: icon
            });
          })) : null));
        } else {
          return false;
        }
      })), _react.default.createElement(_Visibility.default, {
        unmount: true,
        showIf: paginate
      }, "pagina\xE7\xE3o"));
    }
  }]);

  return SummaryList;
}(_react.Component);

SummaryList.propTypes = propTypes;
SummaryList.defaultProps = defaultProps;
var SummaryListWithStyles = (0, _withStyles.withStyles)(function (_ref) {
  var units = _ref.units,
      color = _ref.color,
      breakpoint = _ref.breakpoint;
  return {
    summaryList: {},
    summaryList_clean: _defineProperty({}, breakpoint.mediumAndAbove, {//paddingLeft: units(2),
      //paddingRight: units(2),
    }),
    summaryList_edit: {},
    summaryList__header: {
      paddingTop: 0,
      paddingBottom: units(1.5),
      borderBottomWidth: 1,
      borderBottomStyle: 'solid',
      borderBottomColor: color.blueGrayLight
    },
    summaryList__header__filter: {
      maxWidth: units(24)
    },
    summaryList__list: {
      margin: 0,
      padding: 0,
      listStyle: 'none'
    }
  };
})(SummaryList);
var _default = SummaryListWithStyles;
exports.default = _default;