"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Loader = _interopRequireDefault(require("./Loader"));

var _Shimmer = _interopRequireDefault(require("./Shimmer"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread({}, _reactWithStyles.withStylesPropTypes, {
  active: _propTypes.default.bool,
  disabled: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  fullWidth: _propTypes.default.bool,
  block: _propTypes.default.bool,
  compact: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  mono: _propTypes.default.bool,
  noSpacing: _propTypes.default.bool,
  soft: _propTypes.default.bool,
  primary: _propTypes.default.bool,
  rectangular: _propTypes.default.bool,
  secondary: _propTypes.default.bool,
  shade: _propTypes.default.bool,
  shimmer: _propTypes.default.bool,
  short: _propTypes.default.bool,
  transparent: _propTypes.default.bool,
  type: _propTypes.default.string,
  underlined: _propTypes.default.bool,
  noBorder: _propTypes.default.bool,
  children: _propTypes.default.node
});

var defaultProps = {
  type: 'button'
};

var TabButton = function TabButton(_ref) {
  var styles = _ref.styles,
      active = _ref.active,
      children = _ref.children,
      disabled = _ref.disabled,
      loading = _ref.loading,
      fullWidth = _ref.fullWidth,
      block = _ref.block,
      compact = _ref.compact,
      inverse = _ref.inverse,
      grouped = _ref.grouped,
      groupedFirst = _ref.groupedFirst,
      groupedLast = _ref.groupedLast,
      mono = _ref.mono,
      noSpacing = _ref.noSpacing,
      shade = _ref.shade,
      soft = _ref.soft,
      primary = _ref.primary,
      rectangular = _ref.rectangular,
      secondary = _ref.secondary,
      shimmer = _ref.shimmer,
      short = _ref.short,
      transparent = _ref.transparent,
      type = _ref.type,
      underlined = _ref.underlined,
      noBorder = _ref.noBorder,
      theme = _ref.theme,
      css = _ref.css,
      href = _ref.href,
      large = _ref.large,
      noWrap = _ref.noWrap,
      shadowLevel = _ref.shadowLevel,
      small = _ref.small,
      props = _objectWithoutProperties(_ref, ["styles", "active", "children", "disabled", "loading", "fullWidth", "block", "compact", "inverse", "grouped", "groupedFirst", "groupedLast", "mono", "noSpacing", "shade", "soft", "primary", "rectangular", "secondary", "shimmer", "short", "transparent", "type", "underlined", "noBorder", "theme", "css", "href", "large", "noWrap", "shadowLevel", "small"]);

  return _react.default.createElement("button", _extends({}, props, css(styles.button, active && styles.button_active, loading && styles.button_loading, fullWidth && styles.button_fullWidth, block && styles.button_block, compact && styles.button_compact, disabled && styles.button_disabled, inverse && styles.button_inverse, grouped && styles.button_grouped, groupedFirst && styles.button_groupedFirst, groupedLast && styles.button_groupedLast, mono && styles.button_mono, noSpacing && styles.button_noSpacing, soft && styles.button_soft, primary && styles.button_primary, rectangular && styles.button_rectangular, secondary && styles.button_secondary, shade && styles.button_shade, short && styles.button_short, transparent && styles.button_transparent, underlined && styles.button_underlined, noBorder && styles.button_noBorder), {
    disabled: disabled || loading,
    type: type
  }), loading && shimmer && _react.default.createElement("div", css(styles.shimmer), _react.default.createElement(_Shimmer.default, {
    height: "100%",
    width: "100%"
  })), _react.default.createElement("div", css(styles.button__content, loading && styles.button__content_loading, fullWidth && styles.button__content_fullWidth), children), loading && _react.default.createElement("div", css(styles.button__loader, shimmer && styles.button__loader_shimmer), !shimmer && _react.default.createElement(_Loader.default, {
    small: true,
    primary: inverse && soft,
    secondary: secondary,
    mono: mono
  })));
};

TabButton.propTypes = propTypes;
TabButton.defaultProps = defaultProps;
var TabButtonWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var color = _ref2.color,
      units = _ref2.units,
      font = _ref2.font;
  return {
    button: {
      background: color.shadowWeaker,
      color: color.primary,
      appearance: 'none',
      borderWidth: 0,
      height: units(2.5),
      //minWidth: units(2.5),
      paddingTop: units(0.25),
      paddingRight: units(1.25),
      paddingBottom: units(0.25),
      paddingLeft: units(1.25),
      fontSize: units(0.95),
      outline: 0,
      position: 'relative',
      marginRight: .5,
      marginBottom: 0,
      marginLeft: .5,
      fontWeight: 500,
      fontFamily: font.default,
      boxSizing: 'border-box',
      overflow: 'hidden',
      cursor: 'pointer',
      ':hover': {
        background: color.shadowWeakest
      }
    },
    button_fullWidth: {
      width: '100%'
    },
    button_loading: {
      opacity: 1,
      pointerEvents: 'none'
    },
    button_underlined: {
      borderBottomWidth: 1,
      borderBottomColor: color.primary,
      borderBottomStyle: 'solid'
    },
    button_disabled: {
      opacity: .5,
      pointerEvents: 'none'
    },
    button_mono: {
      backgroundColor: color.transparent,
      borderColor: color.black,
      borderWidth: 1,
      borderStyle: 'solid',
      color: color.black
    },
    button_primary: {
      backgroundColor: color.primary
    },
    button_secondary: {
      backgroundColor: color.transparent,
      borderColor: color.secondary,
      borderWidth: 1,
      borderStyle: 'solid',
      color: color.secondary
    },
    button_inverse: {
      backgroundColor: color.white,
      color: color.primary,
      borderWidth: 0
    },
    button_active: {
      background: color.transparent,
      cursor: 'default',
      ':hover': {
        background: color.transparent
      }
    },
    button_noBorder: {
      border: 'none',
      borderWidth: 0
    },
    button__content: {
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'flex-start',
      opacity: 1,
      transition: 'opacity .2s',
      whiteSpace: 'nowrap',
      userSelect: 'none'
    },
    button__content_fullWidth: {
      justifyContent: 'center'
    },
    button__content_loading: {
      opacity: 0
    },
    button__loader: {
      position: 'absolute',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0,
      display: 'flex',
      alignItems: 'center',
      justifyContent: 'center'
    },
    shimmer: {
      position: 'absolute',
      width: '100%',
      height: '100%',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0
    }
  };
})(TabButton);
var _default = TabButtonWithStyles;
exports.default = _default;