"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Shimmer = _interopRequireDefault(require("./Shimmer"));

var _reactWithStyles = require("react-with-styles");

var _withStyles = require("../helpers/withStyles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread({}, _reactWithStyles.withStylesPropTypes, {
  actionLink: _propTypes.default.string,
  compact: _propTypes.default.bool,
  borderless: _propTypes.default.bool,
  disabled: _propTypes.default.bool,
  focusBorderless: _propTypes.default.bool,
  id: _propTypes.default.string,
  inline: _propTypes.default.bool,
  invalid: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  large: _propTypes.default.bool,
  maxLength: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
  minRows: _propTypes.default.number,
  name: _propTypes.default.string.isRequired,
  onBlur: _propTypes.default.func,
  onChange: _propTypes.default.func,
  onFocus: _propTypes.default.func,
  placeholder: _propTypes.default.string,
  readOnly: _propTypes.default.bool,
  removeMargins: _propTypes.default.bool,
  shimmer: _propTypes.default.bool,
  showCount: _propTypes.default.bool,
  showFakeValuePlaceholder: _propTypes.default.bool,
  showOverflowEllipsis: _propTypes.default.bool,
  small: _propTypes.default.bool,
  value: _propTypes.default.string
});

var defaultProps = {
  minRows: 4
};

var TextAreaOnly = function TextAreaOnly(_ref) {
  var actionLink = _ref.actionLink,
      compact = _ref.compact,
      borderless = _ref.borderless,
      css = _ref.css,
      disabled = _ref.disabled,
      extraPadding = _ref.extraPadding,
      focusBorderless = _ref.focusBorderless,
      id = _ref.id,
      inline = _ref.inline,
      invalid = _ref.invalid,
      inverse = _ref.inverse,
      large = _ref.large,
      maxLength = _ref.maxLength,
      minRows = _ref.minRows,
      name = _ref.name,
      onBlur = _ref.onBlur,
      onChange = _ref.onChange,
      onFocus = _ref.onFocus,
      placeholder = _ref.placeholder,
      readOnly = _ref.readOnly,
      removeMargins = _ref.removeMargins,
      shimmer = _ref.shimmer,
      showCount = _ref.showCount,
      showFakeValuePlaceholder = _ref.showFakeValuePlaceholder,
      showOverflowEllipsis = _ref.showOverflowEllipsis,
      small = _ref.small,
      styles = _ref.styles,
      value = _ref.value;
  return _react.default.createElement("div", css(styles.textAreaOnly, !inline && styles.block, borderless && styles.borderless, disabled && styles.textAreaOnly_disabled, invalid && styles.textAreaOnly_invalid, small && styles.textAreaOnly_small, removeMargins && styles.textAreaOnly_noMargin), shimmer && _react.default.createElement("div", css(styles.shimmer), _react.default.createElement(_Shimmer.default, {
    width: "100%",
    height: "100%"
  })), _react.default.createElement("textarea", _extends({}, css(styles.textAreaOnly__input, extraPadding && styles.textAreaOnly__input_extraPadding, showOverflowEllipsis && styles.textAreaOnly__input_ellipsis, showFakeValuePlaceholder ? styles.textAreaOnly__input_fakeValuePlaceholder : styles.textAreaOnly__input_defaultPlaceholder), {
    disabled: disabled,
    id: id,
    maxLength: maxLength,
    name: name,
    onBlur: onBlur,
    onChange: onChange,
    onFocus: onFocus,
    placeholder: placeholder,
    value: value,
    readOnly: readOnly,
    "aria-readonly": readOnly
  })));
};

TextAreaOnly.propTypes = propTypes;
TextAreaOnly.defaultProps = defaultProps;
var TextAreaOnlyWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var input = _ref2.input,
      color = _ref2.color,
      units = _ref2.units;
  return {
    textAreaOnly: _objectSpread({}, input.default, {
      display: 'inline-flex',
      position: 'relative',
      zIndex: 0,
      flexWrap: 'nowrap',
      alignItems: 'center',
      ':focus-within': _objectSpread({}, input.focus)
    }),
    textAreaOnly_disabled: _objectSpread({}, input.disabled),
    textAreaOnly_invalid: _objectSpread({}, input.invalid),
    textAreaOnly_small: _objectSpread({}, input.small),
    textAreaOnly_noMargin: {
      marginTop: 0,
      marginRight: 0,
      marginBottom: 0,
      marginLeft: 0
    },
    textAreaOnly__input: _objectSpread({}, input.default, {
      border: 0,
      margin: 0,
      background: color.transparent,
      width: '100%',
      height: 'auto',
      paddingTop: input.verticalPadding,
      paddingRight: input.horizontalPadding,
      paddingBottom: input.verticalPadding,
      paddingLeft: input.horizontalPadding,
      boxSizing: 'border-box',
      '::-ms-clear': {
        display: 'none'
      },
      ':focus': {
        outline: 'none',
        boxShadow: 'none',
        border: 0
      }
    }),
    textAreaOnly__input_extraPadding: {},
    textAreaOnly__input_ellipsis: {
      textOverflow: 'ellipsis'
    },
    textAreaOnly__input_defaultPlaceholder: {
      '::placeholder': {
        color: input.placeholderColor,
        opacity: 1
      }
    },
    textAreaOnly__input_fakeValuePlaceholder: {
      '::placeholder': {
        color: input.color,
        opacity: 1
      }
    },
    textAreaOnly__input_inversePlaceholder: {
      '::placeholder': {
        color: color.white,
        opacity: 1
      }
    },
    block: {
      display: 'flex',
      width: '100%'
    },
    borderless: {
      borderColor: input.background
    },
    shimmer: {
      position: 'absolute',
      width: '100%',
      height: '100%',
      top: 0,
      right: 0,
      bottom: 0,
      left: 0
    }
  };
})(TextAreaOnly);
var _default = TextAreaOnlyWithStyles;
exports.default = _default;