"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

var propTypes = {
  children: _propTypes.default.object.isRequired,
  debounceTimeoutMs: _propTypes.default.number,
  debouncedOnChange: _propTypes.default.func,
  throttleTimeoutMs: _propTypes.default.number,
  throttledOnChange: _propTypes.default.func
};

var ThrottledTextInput =
/*#__PURE__*/
function (_Component) {
  _inherits(ThrottledTextInput, _Component);

  function ThrottledTextInput(props) {
    var _this;

    _classCallCheck(this, ThrottledTextInput);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ThrottledTextInput).call(this, props));
    _this.onChange = _this.onChange.bind(_assertThisInitialized(_assertThisInitialized(_this)));
    _this.debouncedOnChange = _lodash.default.debounce(_this.debouncedOnChange.bind(_assertThisInitialized(_assertThisInitialized(_this))), props.debounceTimeoutMs);
    _this.throttledOnChange = _lodash.default.throttle(_this.throttledOnChange.bind(_assertThisInitialized(_assertThisInitialized(_this))), props.throttleTimeoutMs);
    return _this;
  }

  _createClass(ThrottledTextInput, [{
    key: "debouncedOnChange",
    value: function debouncedOnChange(value) {
      this.props.debouncedOnChange(value);
    }
  }, {
    key: "throttledOnChange",
    value: function throttledOnChange(value) {
      this.props.throttledOnChange(value);
    }
  }, {
    key: "onChange",
    value: function onChange(event) {
      var value = event.target.value;
      var _this$props = this.props,
          debounceTimeoutMs = _this$props.debounceTimeoutMs,
          debouncedOnChange = _this$props.debouncedOnChange,
          throttleTimeoutMs = _this$props.throttleTimeoutMs,
          throttledOnChange = _this$props.throttledOnChange;

      if (debouncedOnChange && debounceTimeoutMs) {
        this.debouncedOnChange(value);
      } else if (throttledOnChange && throttleTimeoutMs) {
        this.throttledOnChange(value);
      }
    }
  }, {
    key: "render",
    value: function render() {
      var children = this.props.children;
      return _react.default.cloneElement(_react.default.Children.only(children), {
        onChange: this.onChange
      });
    }
  }]);

  return ThrottledTextInput;
}(_react.Component);

ThrottledTextInput.propTypes = propTypes;
var _default = ThrottledTextInput;
exports.default = _default;