"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

var _Shimmer = _interopRequireDefault(require("./Shimmer"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread({}, _reactWithStyles.withStylesPropTypes, {
  alternativeFont: _propTypes.default.bool,
  center: _propTypes.default.bool,
  defaultFont: _propTypes.default.bool,
  inline: _propTypes.default.bool,
  inverse: _propTypes.default.bool,
  loading: _propTypes.default.bool,
  level: _propTypes.default.oneOf([1, 2, 3, 4, 5, 6]),
  light: _propTypes.default.bool,
  mono: _propTypes.default.bool,
  muted: _propTypes.default.bool,
  negative: _propTypes.default.bool,
  noBottomSpacing: _propTypes.default.bool,
  noSpacing: _propTypes.default.bool,
  noTopSpacing: _propTypes.default.bool,
  positive: _propTypes.default.bool,
  primary: _propTypes.default.bool,
  regular: _propTypes.default.bool,
  right: _propTypes.default.bool,
  secondary: _propTypes.default.bool,
  short: _propTypes.default.bool,
  tall: _propTypes.default.bool,
  title: _propTypes.default.string,
  truncate: _propTypes.default.bool,
  shimmerWidth: _propTypes.default.string,
  children: _propTypes.default.any
});

var defaultProps = {
  level: 1
};

var Title = function Title(_ref) {
  var alternativeFont = _ref.alternativeFont,
      block = _ref.block,
      center = _ref.center,
      children = _ref.children,
      css = _ref.css,
      defaultFont = _ref.defaultFont,
      inline = _ref.inline,
      inverse = _ref.inverse,
      loading = _ref.loading,
      level = _ref.level,
      light = _ref.light,
      mono = _ref.mono,
      muted = _ref.muted,
      negative = _ref.negative,
      noBottomSpacing = _ref.noBottomSpacing,
      noSpacing = _ref.noSpacing,
      noTopSpacing = _ref.noTopSpacing,
      positive = _ref.positive,
      primary = _ref.primary,
      regular = _ref.regular,
      right = _ref.right,
      secondary = _ref.secondary,
      shimmerWidth = _ref.shimmerWidth,
      short = _ref.short,
      styles = _ref.styles,
      tall = _ref.tall,
      title = _ref.title,
      truncate = _ref.truncate;

  var content = function content() {
    switch (level) {
      case 1:
        return _react.default.createElement("h1", css(styles.title__header, block ? styles.block : styles.flex, truncate && styles.title_truncate), children ? children : title);

      case 2:
        return _react.default.createElement("h2", css(styles.title__header, block ? styles.block : styles.flex, truncate && styles.title_truncate), children ? children : title);

      case 3:
        return _react.default.createElement("h3", css(styles.title__header, block ? styles.block : styles.flex, truncate && styles.title_truncate), children ? children : title);

      case 4:
        return _react.default.createElement("h4", css(styles.title__header, block ? styles.block : styles.flex, truncate && styles.title_truncate), children ? children : title);

      case 5:
        return _react.default.createElement("h5", css(styles.title__header, block ? styles.block : styles.flex, truncate && styles.title_truncate), children ? children : title);

      case 6:
        return _react.default.createElement("h6", css(styles.title__header, block ? styles.block : styles.flex, truncate && styles.title_truncate), children ? children : title);

      default:
        return _react.default.createElement("h1", css(styles.title__header, block ? styles.block : styles.flex, truncate && styles.title_truncate), children ? children : title);
    }
  };

  return _react.default.createElement("div", css(styles.title, alternativeFont && styles.title_alternative, center && styles.title_center, defaultFont && styles.title_default, inline && styles.title_inline, inverse && styles.title_inverse, level === 1 && styles.title_level1, level === 2 && styles.title_level2, level === 3 && styles.title_level3, level === 4 && styles.title_level4, level === 5 && styles.title_level5, level === 6 && styles.title_level6, light && styles.title_light, mono && styles.title_mono, muted && styles.title_muted, negative && styles.title_negative, (noTopSpacing || noSpacing) && styles.title_noTopSpacing, (noBottomSpacing || noSpacing) && styles.title_noBottomSpacing, positive && styles.title_positive, primary && styles.title_primary, regular && styles.title_regular, right && styles.title_right, secondary && styles.title_secondary, short && styles.title_short, tall && styles.title_tall), loading ? _react.default.createElement(_Shimmer.default, {
    height: "1ex",
    width: shimmerWidth || '60%'
  }) : content());
};

Title.propTypes = propTypes;
Title.defaultProps = defaultProps;
var TitleWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var units = _ref2.units,
      color = _ref2.color,
      weight = _ref2.weight,
      fontSize = _ref2.fontSize,
      lineHeight = _ref2.lineHeight,
      font = _ref2.font,
      breakpoint = _ref2.breakpoint;
  return {
    title: {
      wordWrap: 'break-word',
      letterSpacing: 'normal',
      fontFamily: font.title ? font.title : font.default,
      color: color.grayDarker,
      fontWeight: weight.bold,
      lineHeight: lineHeight.short,
      margin: 0,
      paddingTop: units(0.5),
      paddingBottom: units(0.5),
      display: 'block',
      textAlign: 'inherit'
    },
    title_default: {
      fontFamily: font.default
    },
    title_alternative: {
      fontFamily: font.alternative ? font.alternative : font.default
    },
    title_inverse: {
      color: color.white
    },
    title_center: {
      textAlign: 'center'
    },
    title_right: {
      textAlign: 'right'
    },
    title_level1: _defineProperty({
      fontSize: fontSize.small.title1
    }, breakpoint.large, {
      fontSize: fontSize.large.title1
    }),
    title_level2: _defineProperty({
      fontSize: fontSize.small.title2
    }, breakpoint.large, {
      fontSize: fontSize.large.title2
    }),
    title_level3: _defineProperty({
      fontSize: fontSize.small.title3
    }, breakpoint.large, {
      fontSize: fontSize.large.title3
    }),
    title_level4: _defineProperty({
      fontSize: fontSize.small.title4
    }, breakpoint.large, {
      fontSize: fontSize.large.title4
    }),
    title_level5: _defineProperty({
      fontSize: fontSize.small.title5
    }, breakpoint.large, {
      fontSize: fontSize.large.title5
    }),
    title_level6: _defineProperty({
      fontSize: fontSize.small.title6
    }, breakpoint.large, {
      fontSize: fontSize.large.title6
    }),
    title_light: {
      fontWeight: weight.light
    },
    title_regular: {
      fontWeight: weight.normal
    },
    title_mono: {
      color: color.black
    },
    title_muted: {
      color: color.blueGrayDark
    },
    title_negative: {
      color: color.error
    },
    title_noBottomSpacing: {
      paddingBottom: 0
    },
    title_noTopSpacing: {
      paddingTop: 0
    },
    title_primary: {
      color: color.primary
    },
    title_positive: {
      color: color.success
    },
    title_secondary: {
      color: color.secondary
    },
    title_short: {
      lineHeight: lineHeight.shorter
    },
    title_tall: {
      lineHeight: lineHeight.tall
    },
    title_truncate: {
      whiteSpace: 'nowrap',
      overflow: 'hidden',
      textOverflow: 'ellipsis',
      width: '100%',
      display: 'inline-block'
    },
    title_inline: {
      display: 'inline-block'
    },
    title__header: {
      fontSize: '1em',
      lineHeight: 'inherit',
      fontWeight: 'inherit',
      color: 'inherit',
      margin: 0,
      padding: 0,
      display: 'flex',
      alignItems: 'center'
    },
    block: {
      display: 'block'
    },
    flex: {
      display: 'flex'
    }
  };
})(Title);
var _default = TitleWithStyles;
exports.default = _default;