"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _withStyles = require("../helpers/withStyles");

var _reactWithStyles = require("react-with-styles");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var propTypes = _objectSpread({}, _reactWithStyles.withStylesPropTypes, {
  container: _propTypes.default.bool,
  id: _propTypes.default.string,
  fullHeight: _propTypes.default.bool,
  gray: _propTypes.default.bool,
  smallContainer: _propTypes.default.bool,
  microContainer: _propTypes.default.bool,
  largeContainer: _propTypes.default.bool,
  largeVerticalSpacing: _propTypes.default.bool,
  smallVerticalSpacing: _propTypes.default.bool,
  verticalSpacing: _propTypes.default.bool,
  largeSpacing: _propTypes.default.bool,
  smallSpacing: _propTypes.default.bool,
  noSpacing: _propTypes.default.bool,
  backgroundColor: _propTypes.default.string,
  relative: _propTypes.default.bool
});

var Wrapper = function Wrapper(_ref) {
  var container = _ref.container,
      fullHeight = _ref.fullHeight,
      id = _ref.id,
      gray = _ref.gray,
      smallContainer = _ref.smallContainer,
      microContainer = _ref.microContainer,
      largeContainer = _ref.largeContainer,
      largeVerticalSpacing = _ref.largeVerticalSpacing,
      smallVerticalSpacing = _ref.smallVerticalSpacing,
      verticalSpacing = _ref.verticalSpacing,
      largeSpacing = _ref.largeSpacing,
      smallSpacing = _ref.smallSpacing,
      noSpacing = _ref.noSpacing,
      backgroundColor = _ref.backgroundColor,
      relative = _ref.relative,
      styles = _ref.styles,
      css = _ref.css,
      children = _ref.children;
  return _react.default.createElement("div", _extends({
    id: id
  }, css(styles.wrapper, (container || microContainer || smallContainer || largeContainer) && styles.wrapper_container, container && styles.wrapper_container_default, microContainer && styles.wrapper_container_micro, smallContainer && styles.wrapper_container_small, largeContainer && styles.wrapper_container_large, fullHeight && styles.wrapper_fullHeight, gray && styles.wrapper_gray, largeVerticalSpacing && styles.wrapper_verticalSpacingLarge, smallVerticalSpacing && styles.wrapper_verticalSpacingSmall, verticalSpacing && styles.wrapper_verticalSpacing, largeSpacing && styles.wrapper_spacingLarge, smallSpacing && styles.wrapper_spacingSmall, noSpacing && styles.wrapper_noSpacing, relative && styles.wrapper_relative, {
    backgroundColor: backgroundColor
  })), children);
};

Wrapper.propTypes = propTypes;
var PageWrapperWithStyles = (0, _withStyles.withStyles)(function (_ref2) {
  var color = _ref2.color,
      units = _ref2.units,
      breakpoint = _ref2.breakpoint,
      container = _ref2.container;
  return {
    wrapper: _defineProperty({
      boxSizing: 'border-box',
      paddingLeft: units(1.5),
      paddingRight: units(1.5),
      width: '100%'
    }, breakpoint.large, {
      paddingLeft: units(4),
      paddingRight: units(4)
    }),
    wrapper_container: {
      marginLeft: 'auto',
      marginRight: 'auto',
      alignSelf: 'center'
    },
    wrapper_container_default: {
      maxWidth: container.default
    },
    wrapper_container_micro: {
      maxWidth: container.micro
    },
    wrapper_container_small: {
      maxWidth: container.small
    },
    wrapper_container_large: {
      maxWidth: container.large
    },
    wrapper_fullHeight: {
      height: '100%'
    },
    wrapper_gray: {
      background: color.grayLight
    },
    wrapper_spacingLarge: _defineProperty({
      paddingLeft: units(3),
      paddingRight: units(3)
    }, breakpoint.large, {
      paddingLeft: units(6),
      paddingRight: units(6)
    }),
    wrapper_spacingSmall: _defineProperty({
      paddingLeft: units(1),
      paddingRight: units(1)
    }, breakpoint.large, {
      paddingLeft: units(3),
      paddingRight: units(3)
    }),
    wrapper_verticalSpacing: {
      paddingTop: units(2.5),
      paddingBottom: units(2.5)
    },
    wrapper_verticalSpacingLarge: {
      paddingTop: units(5),
      paddingBottom: units(5)
    },
    wrapper_verticalSpacingSmall: {
      paddingTop: units(1),
      paddingBottom: units(1)
    },
    wrapper_noSpacing: _defineProperty({
      paddingTop: 0,
      paddingLeft: 0,
      paddingBottom: 0,
      paddingRight: 0
    }, breakpoint.large, {
      paddingTop: 0,
      paddingLeft: 0,
      paddingBottom: 0,
      paddingRight: 0
    }),
    wrapper_relative: {
      position: 'relative'
    }
  };
})(Wrapper);
var _default = PageWrapperWithStyles;
exports.default = _default;