"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ConnectedSelect = exports.ConnectedTextArea = exports.ConnectedInput = exports.ConnectedCheckbox = exports.ConnectedRadioButtonGroup = void 0;

var _react = _interopRequireDefault(require("react"));

var _RadioButtonGroup = _interopRequireDefault(require("./RadioButtonGroup"));

var _Checkbox = _interopRequireDefault(require("./Checkbox"));

var _Input = _interopRequireDefault(require("./Input"));

var _TextArea = _interopRequireDefault(require("./TextArea"));

var _Select = _interopRequireDefault(require("./Select"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var ConnectedRadioButtonGroup = function ConnectedRadioButtonGroup(_ref) {
  var input = _ref.input,
      data = _ref.data,
      valueField = _ref.valueField,
      textField = _ref.textField,
      children = _ref.children,
      _ref$meta = _ref.meta,
      touched = _ref$meta.touched,
      error = _ref$meta.error,
      warning = _ref$meta.warning,
      props = _objectWithoutProperties(_ref, ["input", "data", "valueField", "textField", "children", "meta"]);

  return _react.default.createElement(_RadioButtonGroup.default, _extends({}, input, props, {
    onChange: input.onChange,
    invalid: touched && (error != null || warning != null),
    errorMessage: error || warning
  }), children);
};

exports.ConnectedRadioButtonGroup = ConnectedRadioButtonGroup;

var ConnectedCheckbox = function ConnectedCheckbox(_ref2) {
  var input = _ref2.input,
      data = _ref2.data,
      valueField = _ref2.valueField,
      textField = _ref2.textField,
      children = _ref2.children,
      _ref2$meta = _ref2.meta,
      touched = _ref2$meta.touched,
      error = _ref2$meta.error,
      warning = _ref2$meta.warning,
      props = _objectWithoutProperties(_ref2, ["input", "data", "valueField", "textField", "children", "meta"]);

  return _react.default.createElement(_Checkbox.default, _extends({}, input, props, {
    value: input.checked,
    onChange: input.onChange,
    invalid: touched && (error != null || warning != null),
    checked: input.value !== false && input.value !== ''
  }), children);
};

exports.ConnectedCheckbox = ConnectedCheckbox;

var ConnectedInput = function ConnectedInput(_ref3) {
  var input = _ref3.input,
      data = _ref3.data,
      valueField = _ref3.valueField,
      textField = _ref3.textField,
      _ref3$meta = _ref3.meta,
      touched = _ref3$meta.touched,
      error = _ref3$meta.error,
      warning = _ref3$meta.warning,
      props = _objectWithoutProperties(_ref3, ["input", "data", "valueField", "textField", "meta"]);

  return _react.default.createElement(_Input.default, _extends({}, input, props, {
    onChange: input.onChange,
    invalid: touched && (error != null || warning != null),
    errorMessage: error || warning
  }));
};

exports.ConnectedInput = ConnectedInput;

var ConnectedTextArea = function ConnectedTextArea(_ref4) {
  var input = _ref4.input,
      data = _ref4.data,
      valueField = _ref4.valueField,
      textField = _ref4.textField,
      _ref4$meta = _ref4.meta,
      touched = _ref4$meta.touched,
      error = _ref4$meta.error,
      warning = _ref4$meta.warning,
      props = _objectWithoutProperties(_ref4, ["input", "data", "valueField", "textField", "meta"]);

  return _react.default.createElement(_TextArea.default, _extends({}, input, props, {
    onChange: input.onChange,
    invalid: touched && (error != null || warning != null),
    errorMessage: error || warning
  }));
};

exports.ConnectedTextArea = ConnectedTextArea;

var ConnectedSelect = function ConnectedSelect(_ref5) {
  var input = _ref5.input,
      data = _ref5.data,
      valueField = _ref5.valueField,
      textField = _ref5.textField,
      _ref5$meta = _ref5.meta,
      touched = _ref5$meta.touched,
      error = _ref5$meta.error,
      warning = _ref5$meta.warning,
      props = _objectWithoutProperties(_ref5, ["input", "data", "valueField", "textField", "meta"]);

  return _react.default.createElement(_Select.default, _extends({}, input, props, {
    onChange: input.onChange,
    onBlur: function onBlur() {
      return input.onBlur(input.value);
    },
    invalid: touched && (error != null || warning != null),
    errorMessage: error || warning
  }));
};

exports.ConnectedSelect = ConnectedSelect;