"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cel = cel;
exports.currency = exports.cep = exports.cpf = exports.date = exports.tel = void 0;

var _createNumberMask = _interopRequireDefault(require("text-mask-addons/dist/createNumberMask"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function cel(userInput) {
  var numbers = userInput.match(/\d/g);
  var numberLength = 0;

  if (numbers) {
    numberLength = numbers.join("").length;
  }

  if (numberLength > 10) {
    return ['(', /[1-9]/, /[1-9]/, ')', ' ', /\d/, /\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/];
  } else {
    return ['(', /[1-9]/, /[1-9]/, ')', ' ', /\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/];
  }
}

var tel = function tel() {
  return ['(', /[1-9]/, /[1-9]/, ')', ' ', /\d/, /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/, /\d/];
};

exports.tel = tel;

var date = function date() {
  return [/\d/, /\d/, '/', /\d/, /\d/, '/', /\d/, /\d/, /\d/, /\d/];
};

exports.date = date;

var cpf = function cpf() {
  return [/\d/, /\d/, /\d/, '.', /\d/, /\d/, /\d/, '.', /\d/, /\d/, /\d/, '-', /\d/, /\d/];
};

exports.cpf = cpf;

var cep = function cep() {
  return [/\d/, /\d/, '.', /\d/, /\d/, /\d/, '-', /\d/, /\d/, /\d/];
};

exports.cep = cep;
var currency = (0, _createNumberMask.default)({
  prefix: 'R$ ',
  allowDecimal: true,
  thousandsSeparatorSymbol: '.',
  decimalSymbol: ','
});
exports.currency = currency;